/*
 * crypUtil.java
 *
 * Created on 30 de julio de 2007, 13:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.crypto;

//TODO limpiar y comentar

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import javax.swing.JComboBox;

/**
 *
 * @author JL
 */
public class crypUtil {
    
    public static final String MD5 = "MD5";
    public static final String SHA = "SHA";
    public static final String SSHA = "SSHA";
    public static final String SMD5 = "SMD5";
       
    
    /** Creates a new instance of crypUtil */
    public crypUtil() {
    }
    
    
  /**
     * Takes a binary byte array and converts it to base64 mime
     * encoded data.
     *
     * @param byteArray an array of 8 bit bytes to be converted
     * @return the resultant encoded string
     */
    
    public static String binaryToString(byte[] byteArray) {
        return binaryToString(byteArray, 0);
    }

    /**
     * Takes a binary byte array and converts it to base64 mime
     * encoded data.
     *
     * @param byteArray an array of 8 bit bytes to be converted
     * @param offset    The first line of the string may be offset by
     *                  by this many characters for nice formatting (e.g. in
     *                  an ldif file, the first line may include 'att value = ...'
     *                  at the beginning of the base 64 encoded block).
     * @return the resultant encoded string
     */

    public static String binaryToString(byte[] byteArray, int offset) {
        if (byteArray == null) return null;  

        int arraySize = byteArray.length;
        int thirdSize = arraySize / 3;

        byte[] base64Data = encode(byteArray);

        if (base64Data == null) return null;  // Exception occurred.

        return format(base64Data, offset);

    }

    /**
     * This returns a formatted string representing the base64 data.
     *
     * @param base64Data a byte array of base64 encoded data.
     * @param offset     the string is formatted to fit inside column 76.
     *                   The offset number provides for the first line to be
     *                   foreshortened (basically for pretty formatting in ldif
     *                   files).
     */


    public static String format(byte[] base64Data, int offset) {

        String data;
        try {
            data = new String(base64Data, "US-ASCII");
        } catch (Exception e){
            data = new String(base64Data);  // should be equivalent to above
        }
                
        StringBuffer buffer = new StringBuffer(data);

        int i = 76 - offset;
        while (i < base64Data.length) {
            buffer.insert(i, "\r\n ");
            i += 78;
        }

        return buffer.toString();
    }    
    
    public static byte[] encode(byte[] byteArray) {
        try {
            int arraySize = byteArray.length;
            int outputSize = (arraySize % 3 == 0) ? (arraySize / 3) * 4 : ((arraySize / 3) + 1) * 4;
            byte[] output = new byte[outputSize];                        
    
            int bufferLength = 0;

            for (int i = 0; i <= (arraySize - 3); i += 3) {
                convertTriplet(byteArray[i], byteArray[i + 1], byteArray[i + 2], 3, output, bufferLength);
                bufferLength += 4;
            }

            switch (arraySize % 3){
                case 0: break;
                case 1: convertTriplet(byteArray[arraySize - 1], (byte) 0, (byte) 0, 1, output, bufferLength);break;
                case 2: convertTriplet(byteArray[arraySize - 2], byteArray[arraySize - 1], (byte) 0, 2, output, bufferLength);break;
            }
            return output;
        }
        catch (KemitBase64EncodingException e) {
            return null;
        }
    }

    /**
     * Encode an arbitrary byte array into an array of base64 encoded bytes.
     * That is, bytes that have values corresponding to the ascii values of base 64
     * data, and can be type cast to those chars.
     *
     * @param byteArray the raw data to encode
     * @param start     the number of padding spaces to have at the start (must be less than colSize)
     * @param colSize   the length of each line of text (i.e. the right hand margin).  Must
     *                  be a multiple of 4.
     * @return the base64 encoded bytes (the length of this is ~ 4/3 the length of
     *         the raw data).
     */

    public static byte[] encodeFormatted(byte[] byteArray, int start, int colSize) throws KemitBase64EncodingException {
        try {
            if (colSize % 4 != 0) {
                throw new KemitBase64EncodingException("error in encodeFormatted - colSize not a multiple of 4.");
            }

            if (start >= colSize) {
                throw new KemitBase64EncodingException("error in encodeFormatted - start is not less than colSize.");
            }

            int arraySize = byteArray.length;
            int outputSize = start + ((arraySize % 3 == 0) ? (arraySize / 3) * 4 : ((arraySize / 3) + 1) * 4);
            outputSize += (outputSize / colSize) + 1;  // allow for new lines!
            byte[] output = new byte[outputSize];
            
            // iterate through array, reading off byte triplets and converting to base64
        
            for (int i = 0; i < start; i++)
                output[i] = (byte) ' ';   // pad to 'start' with spaces.

            int bufferLength = start;

            for (int i = 0; i <= (arraySize - 3); i += 3) {
                convertTriplet(byteArray[i], byteArray[i + 1], byteArray[i + 2], 3, output, bufferLength);
                bufferLength += 4;

                if (bufferLength % (colSize + 1) == colSize) {
                    output[bufferLength++] = (byte) '\n';
                }
            }

            switch (arraySize % 3) {
                case 0:break;
                case 1:
                    convertTriplet(byteArray[arraySize - 1], (byte) 0, (byte) 0, 1, output, bufferLength);
                    bufferLength += 4;
                    break;
                case 2:
                    convertTriplet(byteArray[arraySize - 2], byteArray[arraySize - 1], (byte) 0, 2, output, bufferLength);
                    bufferLength += 4;
                    break;
            }
        
            // final '\n'
            if (bufferLength < outputSize) {
                output[bufferLength++] = (byte) '\n';
            }
            else
            {
                System.err.println("wierdness in formatted base 64 : bufferlength (" + bufferLength + ") != 1 + outputsize (" + outputSize + ")");
            }

            return output;
        }
        catch (KemitBase64EncodingException e)
        {
            return null;
        }
        catch (Exception e2)
        {
            System.err.println("unexpected error in base 64 encoding");
            e2.printStackTrace();
            return null;
        }
    }


    /**
     * Takes a base 64 encoded string and converts it to a
     * binary byte array.
     *
     * @param chars a string of base64 encoded characters to be converted
     * @return the resultant binary array
     */

    public static byte[] stringToBinary(String chars) {
        if (chars == null) return null;
        byte charArray[];

        try { charArray = chars.getBytes("US-ASCII"); } catch (UnsupportedEncodingException e) {charArray = chars.getBytes();}
        return decode(charArray);
    }


    /**
     * Decodes a byte array containing base64 encoded data.
     *
     * @param rawData a byte array, each byte of which is a seven-bit ASCII value.
     * @return the raw binary data, each byte of which may have any value from
     *         0 - 255.  This value will be null if a decoding error occurred.
     */

    public static byte[] decode(byte[] rawData) {
        try {

            int resultLength = (int) (rawData.length * .75); // set upper limit for binary array

            byte result[] = new byte[resultLength];

            int noBytesWritten = 0;
            int validCharacters = 0;

            byte c;
            byte quad[] = new byte[4]; // temp store for a quad of base64 byte characters
            int bytes;                // temp store for a triplet of bytes
            int numfound = 0;          // number of chars found for quad
             
             
            // iterate through, finding valid quads, and converting to byte triplets 
    
            for (int i = 0; i < rawData.length; i++) {
                c = rawData[i];
                if ((c >= (byte) 'A' && c <= (byte) 'Z') || (c >= (byte) 'a' && c <= (byte) 'z') || (c >= '0' && c <= '9') || (c == '+') || (c == (byte) '/') || (c == (byte) '=')){
                    quad[numfound++] = c;
                    validCharacters++;
                }
                else if (" \r\n\t\f".indexOf((char) c) == -1) {
                    //CBUtility.log("error... bad character (" + (char)c + ") read from base64 encoded string", 6);
                    return null;
                }

                // write the quad; paying special attention to possible 'filler'
                // characters '=' or '==' at the end of the string (see rfc).
                 
                if (numfound == 4) {
                    bytes = convertQuad(quad);
                    result[noBytesWritten++] = (byte) ((bytes & 0xFF0000) >> 16);
                    if (c != '=') {
                        result[noBytesWritten++] = (byte) ((bytes & 0xFF00) >> 8);
                        result[noBytesWritten++] = (byte) (bytes & 0xFF);
                    }
                    else if (rawData[i - 1] != '=') {
                        result[noBytesWritten++] = (byte) ((bytes & 0xFF00) >> 8);
                        if ((bytes & 0xFF) > 0) return null;                        
                    }
                    else if ((bytes & 0xFF00) > 0) return null;
                    numfound = 0;
                }
            }
             
            // check that the number of real characters is correct - must be cleanly
            // divisible by 4...
             
            if (validCharacters % 4 != 0) return null;


            byte finalResult[] = new byte[noBytesWritten];
            System.arraycopy(result, 0, finalResult, 0, noBytesWritten);
            return finalResult;
        }
        catch (Exception e)
        {
            //CBUtility.log("unable to create final decoded byte array from base64 bytes: " + e, 6);
            return null;
        }

    }

    /**
     * Decodes a byte array containing base64 encoded data.
     *
     * @param chars a String, each character of which is a seven-bit ASCII value.
     * @return the raw binary data, each byte of which may have any value from
     *         0 - 255.  This value will be null if a decoding error occurred.
     */

    public static byte[] decode(String chars) throws KemitBase64EncodingException {

        if (chars == null) return null;

        byte rawData[];

        try { rawData = chars.getBytes("US-ASCII"); }
        catch (UnsupportedEncodingException e){
            throw new KemitBase64EncodingException("unable to convert base64 encoded data to bytes using US-ASCII encoding", e);
        }

        int resultLength = (int) (rawData.length * .75); // set upper limit for binary array
        byte result[] = new byte[resultLength];

        int noBytesWritten = 0;
        int validCharacters = 0;

        byte c;
        byte quad[] = new byte[4]; // temp store for a quad of base64 byte characters
        int bytes;                // temp store for a triplet of bytes
        int numfound = 0;          // number of chars found for quad

        for (int i = 0; i < rawData.length; i++) {
            c = rawData[i];
            if ((c >= (byte) 'A' && c <= (byte) 'Z') || (c >= (byte) 'a' && c <= (byte) 'z') || (c >= '0' && c <= '9') || (c == '+') || (c == (byte) '/') || (c == (byte) '=')){
                quad[numfound++] = c;
                validCharacters++;
            }
            else if (" \r\n\t\f".indexOf((char) c) == -1){
                throw new KemitBase64EncodingException("error... bad character (" + (char) c + ") read from base64 encoded string");
            }

            if (numfound == 4) {
                bytes = convertQuad(quad);
                result[noBytesWritten++] = (byte) ((bytes & 0xFF0000) >> 16);
                if (c != '=') {
                    result[noBytesWritten++] = (byte) ((bytes & 0xFF00) >> 8);
                    result[noBytesWritten++] = (byte) (bytes & 0xFF);
                }
                else if (rawData[i - 1] != '='){
                    result[noBytesWritten++] = (byte) ((bytes & 0xFF00) >> 8);
                    if ((bytes & 0xFF) > 0){
                        throw new KemitBase64EncodingException("Warning: Corrupt base64 Encoded Data - contains trailing bits after end of base 64 data.");
                    }
                }
                else if ((bytes & 0xFF00) > 0){
                    throw new KemitBase64EncodingException("Warning: Corrupt base64 Encoded File  - contains trailing bits after end of base64 data.");
                }
                numfound = 0;
            }
        }

        if (validCharacters % 4 != 0) {
            throw new KemitBase64EncodingException("Warning: Corrupt base64 Encoded Data - Length (" + validCharacters + ") of valid characters not divisible by 4.");
        }

        byte finalResult[] = new byte[noBytesWritten];
        System.arraycopy(result, 0, finalResult, 0, noBytesWritten);
        return finalResult;

    }


    private static void convertTriplet(byte a, byte b, byte c, int Num, byte[] buff, int buffpos) throws KemitBase64EncodingException {
        byte w, x, y, z;  // the four 6 bit values extracted.
        int trip = (a << 16) | ((b << 8) & 0xFF00) | (c & 0xFF);

        w = (byte) ((trip & 0xFC0000) >> 18);
        x = (byte) ((trip & 0x03F000) >> 12);
        y = (byte) ((trip & 0x000FC0) >> 6);
        z = (byte) (trip & 0x00003F);

        buff[buffpos] = convertFrom6Bit(w);
        buff[buffpos + 1] = convertFrom6Bit(x);

        if (Num == 1) {
            buff[buffpos + 2] = (byte) '=';
            buff[buffpos + 3] = (byte) '=';
        }
        else{
            buff[buffpos + 2] = convertFrom6Bit(y);

            if (Num == 2) { buff[buffpos + 3] = (byte) '=';}
            else {buff[buffpos + 3] = convertFrom6Bit(z);}
        }
    }

    /**
     * Use rfc 1521 specified character conversions
     * (I wonder if a preset array would be faster?)
     *
     * @param b the 6 significant bit byte to be converted
     * @return the converted base64 character
     */

    // this might be sped up using an array index as provided above...

    private static byte convertFrom6Bit(byte b) throws KemitBase64EncodingException {
        byte c;

        if (b < 26)         return (byte) ('A' + b);           // 'A' -> 'Z'
        else if (b < 52)    return (byte) (('a' - 26) + b);  // 'a' -> 'z'
        else if (b < 62)    return (byte) (('0' - 52) + b);  // '0' -> '9'
        else if (b == 62)   return ((byte) '+');
        else if (b == 63)   return ((byte) '/');
        else {
            throw new KemitBase64EncodingException("erroroneous value " + (char) b + " passed in convertFrom6bit");
        }
    }

    /**
     * Use rfc 1521 specified character conversions
     * (I wonder if a preset array would be faster?)
     *
     * @param c a byte representing a single base64 encoded character
     * @return the corresponding raw 6 bit 'true' value.
     */

    private static byte convertTo6Bit(byte c) throws KemitBase64EncodingException {
        if (c == (byte) '+')        return 62;
        else if (c == (byte) '/')   return 63;
        else if (c == (byte) '=')   return 0;
        else if (c <= (byte) '9')   return (byte) (c - (byte) '0' + 52);
        else if (c <= (byte) 'Z')   return (byte) (c - (byte) 'A');
        else if (c <= (byte) 'z')   return (byte) (c - (byte) 'a' + 26);
        else {
            throw new KemitBase64EncodingException("erroroneous value " + (char) c + " passed in convertTo6bit");
        }
    }

    /**
     * Takes a triplet of base64 encoded characters, and returns
     * a triplet of appropriate bytes
     *
     * @param quad four base 64 encoded characters
     * @return the corresponding 'true' 24 bit value, as an int.
     */

    private static int convertQuad(byte[] quad) throws KemitBase64EncodingException {
        byte a = convertTo6Bit(quad[0]);
        byte b = convertTo6Bit(quad[1]);
        byte c = convertTo6Bit(quad[2]);
        byte d = convertTo6Bit(quad[3]);

        int ret = (a << 18) + (b << 12) + (c << 6) + d;

        return ret;
    }    
    
    /// 
    
    
    
    
    
    public static byte[] mdDecode(String s, int type, byte[] salt) {
        try {
            MessageDigest md;
            StringBuffer hexString = new StringBuffer();

            if ((type == 5) && (salt != null)) { md = MessageDigest.getInstance(SHA); hexString.append("{" + SSHA + "}"); }
            else if (type == 4) { md = MessageDigest.getInstance(SHA);hexString.append("{" + SHA + "}"); }
            else if ((type == 3) && (salt != null)) {md = MessageDigest.getInstance(MD5);hexString.append("{" + SMD5 + "}");}
            else if (type == 2) {md = MessageDigest.getInstance(MD5);hexString.append("{" + MD5 + "}");}
            else {return (null);}

            md.reset();
            md.update(s.getBytes("UTF-8"));

            if (salt != null) {
                // The way the salted hashes work is the following:
                // h=HASH(pwd+salt)
                //
                // To be able to restore the salt it needs to be appended
                // to the resulting hash.
                // {SMD5|SSHA}base64(h+salt)

                // So, lets append the salt to the pwd-buffer in md.
                md.update(salt);

                // Calculate the hash-value of s+salt
                byte[] buff = md.digest();

                // And append the salt to the hashed pwd.
                byte[] new_buf = new byte[buff.length + salt.length];
                for (int x = 0; x < buff.length; x++)
                    new_buf[x] = buff[x];

                for (int x = buff.length; x < new_buf.length; x++)
                    new_buf[x] = salt[x - buff.length];

                // New_buf now contains the 16(MD5), resp. 20(SHA1) hash
                // bytes and the salt.
                hexString.append(binaryToString(new_buf));
            }
            else {
                byte[] buff = md.digest();
                hexString.append(binaryToString(buff));
            }

            return hexString.toString().getBytes("UTF-8");
        }
        catch (UnsupportedEncodingException e) {
            //log.log(Level.WARNING, "Unexpected error encoding password ", e);
            e.printStackTrace();
            return new byte[0];
        }
        catch (java.security.NoSuchAlgorithmException e) {
            //log.log(Level.WARNING, "Unexpected error encoding password ", e);
            e.printStackTrace();
            return new byte[0];
        }
    }    
    
    protected String stringEncode(byte[] b) {
        if (b == null || b.length == 0) {
            return new String();
        }
        else {
            try {
                return new String(b, "UTF-8");
            }
            catch (UnsupportedEncodingException e) {
                //mensage("Unexpected error decoding password "+e);
                e.printStackTrace();
                return new String(b);  
            }
        }
    }
     
    static byte[] plainDecode(String s)
    {
        try
        {
            return s.getBytes("UTF-8");
        }
        catch (UnsupportedEncodingException e)
        {
            //log.log(Level.WARNING, "Unexpected error encoding password ", e);
            e.printStackTrace();
            return new byte[0];
        }
    }
  /**
     * Converts between text and a byte array
     */
     
          
     
   /**
     * Verifies a given password against the password stored in the userPassword-attribute.
     * <p/>
     * The userPassword-value should follow the following format: - {MD5}base64(MD5-hash) - {SHA}base64(SHA-hash) -
     * {SMD5}base64(MD5-hash+salt bytes) - {SSHA}base64(SHA-hash+salt bytes) - plaintext password
     * <p/>
     * If the userPassword value does not start with one of the prefixes {MD5}, {SMD5}, {SHA} or {SSHA} it will be
     * handled as a plaintext pwd.
     * <p/>
     * The Unix {CRYPT}-Scheme is currently not supported.
     * @param oPwd The original pwd stored in the userPassword value.
     * @param nPwd The password in plaintext that should be verified against the hashed pwd stored in the userPassword
     * field.
     * @return True - if the given plaintext pwd matches with the hashed pwd in the userPassword field, otherwise false.
     *         Returns also false for the {CRYPT}-scheme as it is currently unsupported.
     */
    static boolean passwordVerify(String oPwd, String nPwd)
    {
        if (oPwd.startsWith("{MD5}")) {
            nPwd = new String(mdDecode(nPwd, 2, null));
        }
        else if (oPwd.startsWith("{SMD5}")) {
            // SMD5 means "Salted MD5". The "salt" is a
            // String of an arbitrary length appended to
            // the given MD5 hash in oPwd.

            // To get the salt bytes first we need to base64-decode
            // the pwd hash and store it in tmp.
            byte[] tmp = stringToBinary(oPwd.substring(6));

            // The length of an MD5-hash is always 16 Bytes. To get
            // the size of the salt we need to subtract 16 Bytes from
            // the total length of the base64-decoded String.
            if (tmp != null) {
                int len = tmp.length - 16;
                if (len > 0) {
                    // Get the salt Bytes. As the MD5-Hash takes 16 Bytes,
                    // the remaining Bytes will be the salt.
                    byte[] salt = new byte[len];
                    for (int x = 0; x < len; x++)
                        salt[x] = tmp[x + 16];

                    // nPwd is the given pwd in cleartext, so
                    // we create the hash for the given pwd
                    // and store it again in nPwd.
                    nPwd = new String(mdDecode(nPwd, 3, salt));
                }
            }
        }
        else if (oPwd.startsWith("{SHA}")) {
            // nPwd is the given pwd in cleartext, so
            // we create the hash for the given pwd
            // and store it again in nPwd.
            nPwd = new String(mdDecode(nPwd, 4, null));
        }
        else if (oPwd.startsWith("{SSHA}")) {
            // SSHA means "Salted SHA-1". The "salt" is a
            // String of an arbitrary length appended to
            // the given SHA-1 hash in oPwd.

            // To get the salt bytes first we need to base64-decode
            // the pwd hash and store it in tmp.
            byte[] tmp = stringToBinary(oPwd.substring(6));

            // The length of an SHA-1-hash is always 20 Bytes. To get
            // the size of the salt we need to subtract 20 Bytes from
            // the total length of the base64-decoded String.
            if (tmp != null) {
                int len = tmp.length - 20;
                if (len > 0) {
                    // Get the salt Bytes. As the SHA-1-Hash takes 20 Bytes,
                    // the remaining Bytes will be the salt.
                    byte[] salt = new byte[len];
                    for (int x = 0; x < len; x++)
                        salt[x] = tmp[x + 20];

                    // nPwd is the given pwd in cleartext, so
                    // we create the hash for the given pwd
                    // and store it again in nPwd.
                    nPwd = new String(mdDecode(nPwd, 5, salt));
                }
            }
        }
        else {
            // nPwd is already cleartext, no need for
            // hashing it.
            nPwd = new String(plainDecode(nPwd));
        }
        // Compare the two hashed pwd-Strings and return true if
        // they match, otherwise false. If the Unix {CRYPT}-scheme
        // is used we return false as well.
        
        if (nPwd.equals(oPwd)) return (true);

        return (false);
    }
    
        
}
