/* 
 * @(#)Getattr.java	1.5 00/04/28
 */ 

package kemit.ldap;

import java.text.SimpleDateFormat;
import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;
import kemit.crypto.sambaPasswords;
import kemit.ldap.objectos.GrupoLDAP;
import kemit.ldap.objectos.UsuarioLDAP;
import kemit.util.OpenLdapUtil;

/**
 * Demonstrates how to retrieve an attribute of a named object.
 * 
 * usage: java Getattr
 */
class Getattr {

    DirContext ctx;   
    String schemaRoot;
    final static String subschemaAttributeName = "subschemaSubentry";
    HashMap oids = new HashMap(1000);           // a fast lookup list of oids to descriptive names.
    Attributes rawSchemaAttributes = null;      

    public static void main(String[] args) {
	// Identify service provider to use
        
        Getattr ga=new Getattr();
        
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://192.168.1.123:389/dc=intracentre");
        
        env.put(Context.SECURITY_AUTHENTICATION, "simple");
        env.put(Context.SECURITY_PRINCIPAL, "cn=Administrator,dc=intracentre");
        env.put(Context.SECURITY_CREDENTIALS, "asesino");
        
        //env.put(Context.SECURITY_AUTHENTICATION, "none");
        env.put("java.naming.ldap.version", "3");
        
        OpenLdapUtil util=new OpenLdapUtil(false);

	try {

	    ga.ctx = new InitialDirContext(env);
                       
            Attributes atn=new BasicAttributes(true);
            Attribute oc2 = new BasicAttribute("objectclass");        
            //oc2.add("sambaDomain");

//        oc2.add("posixAccount");
//        oc2.add("inetOrgPerson");
//        oc2.add("shadowAccount");
//        oc2.add("top");
//        oc2.add("sambaSamAccount");
            
            atn.put(oc2);
            
            
            NamingEnumeration answer = ga.ctx.search("", atn);                         
            
            while (answer.hasMore()) {
//                System.out.println(""+answer.next());
                SearchResult attrR = (SearchResult)answer.next();
                System.out.println(attrR.getName());
                System.out.println(attrR.getClassName());
                NamingEnumeration enum1 = attrR.getAttributes().getAll();
                while (enum1.hasMore()) {
                    Attribute attr = (Attribute)enum1.next();
                    System.out.println("Attributo="+attr.getID()+" valor="+attr.get()+" ID="+attr.getAttributeDefinition().getAttributes(""));
                }

                //System.out.println("Attributo="+attr.getID()+" valor="+attr.get()+" ID="+attr.getAttributeDefinition().getAttributes(""));
                
            }
                        
/*
            Attributes answer2 = ga.ctx.getAttributes("uid=jl, ou=people", null);
    
            NamingEnumeration enum1 = answer2.getAll();
            while (enum1.hasMore()) {
                Attribute attr = (Attribute)enum1.next();
                System.out.println("Attributo="+attr.getID()+" valor="+attr.get()+" ID="+attr.getAttributeDefinition().getAttributes(""));
            }
            
            
            
            System.out.println("\n\n");
*/            

            // Get the schema object for "person"
/*            
            
    DirContext tedClasses = ga.ctx.getSchemaClassDefinition("uid=jl,ou=people");

    // Enumerate the class definitions
    NamingEnumeration enum2 = tedClasses.search("", null);
    while (enum2.hasMore()) {
        System.out.println(enum2.next());
    }
 *
 */

    //Inserta usuario
    
//    try {
//            String pr="inicio altas";
//            GregorianCalendar gc=new GregorianCalendar();
//            SimpleDateFormat df = new SimpleDateFormat ("dd/MM/yyyy HH:mm:ss");
//            try { pr=df.format(gc.getTime())+" - "+pr+"\n"; } catch (Exception e) {e.printStackTrace();}
//            System.out.println(pr);
//
//            for (int i=1;i<100;i++) {
//                String distinguishedName = "uid=" + "perro"+i + ",ou=people" ;
//                System.out.println(distinguishedName); //cn=newusers,ou=agenda,dc=alcatel,dc=fr
//                Attributes newAttributes = new BasicAttributes(true);        
//                Attribute oc = new BasicAttribute("objectclass");        
//                oc.add("posixAccount");
//                oc.add("inetOrgPerson");
//                oc.add("shadowAccount");
//                oc.add("top");
//                oc.add("sambaSamAccount");
//
//                newAttributes.put(new BasicAttribute("userPassword", "perro"+i));
//                newAttributes.put(oc);
//                newAttributes.put(new BasicAttribute("cn", "Perro paco"));
//                newAttributes.put(new BasicAttribute("sn","Polaco"));
//                newAttributes.put(new BasicAttribute("uid", "perro"+i));
//                newAttributes.put(new BasicAttribute("gidNumber", "2002"));
//                newAttributes.put(new BasicAttribute("uidNumber", "2302"));
//                newAttributes.put(new BasicAttribute("homeDirectory", "/home/perro"+i));
//                newAttributes.put(new BasicAttribute("loginShell", "/bin/bash"));
//
//                newAttributes.put(new BasicAttribute("sambaSID", "S-1-5-21-1390374040-3079972134-1807028711-2000"));
//                newAttributes.put(new BasicAttribute("sambaPrimaryGroupSID", "S-1-5-21-1390374040-3079972134-1807028711-1201"));
//                newAttributes.put(new BasicAttribute("sambaAcctFlags", "[U          ]"));
//                newAttributes.put(new BasicAttribute("sambaLMPassword", sambaPasswords.SambaLMPassword("perro"+i))); // "81CB976D7544E9ACAAD3B435B51404EE"
//                newAttributes.put(new BasicAttribute("sambaNTPassword", sambaPasswords.SambaNTPassword("perro"+i))); // "7BD9E8E8A255D3DA134EFBA8B8B0DA09"        
//                //System.out.println("New user in database LDAP -->"+" " + "perro"+i);
//                ga.ctx.createSubcontext(distinguishedName, newAttributes);
//            }
//            pr="fin";
//            gc=new GregorianCalendar();            
//            try { pr=df.format(gc.getTime())+" -  "+pr+"\n"; } catch (Exception e) {e.printStackTrace();}
//            System.out.println(pr);
//            
//    }
//    catch (Exception e) {
//        System.out.println("create error: " + e);
//        e.printStackTrace();        
//    }

//            String pr="inicio bajas";
//            GregorianCalendar gc=new GregorianCalendar();
//            SimpleDateFormat df = new SimpleDateFormat ("dd/MM/yyyy HH:mm:ss");
//            try { pr=df.format(gc.getTime())+" - "+pr+"\n"; } catch (Exception e) {e.printStackTrace();}
//            System.out.println(pr);
//
//            for (int i=1;i<100;i++) {
//                UsuarioLDAP jo=new UsuarioLDAP();
//                jo.setUid("perro"+i);
//                //jo.borrarEnServerLDAP(ga.ctx);
//            }
//            pr="fin bajas";
//            gc=new GregorianCalendar();            
//            try { pr=df.format(gc.getTime())+" -  "+pr+"\n"; } catch (Exception e) {e.printStackTrace();}
//            System.out.println(pr);
            

            GrupoLDAP g=new GrupoLDAP();
            g.setCn("Administradors");
            Hashtable t=new Hashtable();                                                            
            UsuarioLDAP jo=new UsuarioLDAP();
            jo.setUid("perro");
            t.put("perro",jo);
            g.setMiembros(t);
            
            //g.addMemberLDAP(ga.ctx,jo);
            
            //jo.borrarEnServer(ga.ctx);

            
	    ga.ctx.close();
	} catch (NamingException e) {
	    System.err.println("Error: " + e);
            e.printStackTrace();
	}
    }
}

