/*
 * Principal.java
 *
 * Created on 21 de julio de 2007, 20:13
 */

package kemit.ldap;

import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyVetoException;
import java.io.*;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.prefs.Preferences;
import javax.naming.*;
import javax.naming.directory.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import kemit.component.KCheckBoxJList;


import kemit.ldap.objectos.*;
import kemit.util.*;
import kemit.util.OpenLdapUtil;


import kemit.util.SplashWindow;
import org.w3c.dom.Document;
import symmetric.ObjectThread;


/**
 *
 * @author  JL
 */
public class Principal extends javax.swing.JFrame {
    
    static Principal yo=null;
    private Session ss=null;
    
    public boolean debug=false;
    
    public Vector usuarios,grupos;
    public Vector usuariosNEW,gruposNEW;
    
    public Vector unixUsers,unixGroups;
    
    private Vector gruposUtil;
    public Vector usuCreados;
    
    private int intentos;
    Dimension screenSize;
    
    public int maxUID=1000;
    public int maxGID=1000;
    
    private int SAMBA=0;
    
    Preferences preferencias = Preferences.userNodeForPackage(kemit.ldap.Principal.class);
    
    
    final String pUsuario="pUsuario";
    final String pDominio="pDominio";
    final String pAlgoritmo="pAlgoritmo";
    final String pGuardaHomes="pGuardaHomes";
    final String pDirGuardaHomes="pDirGuardaHomes";
    final String pDebug="pDebug";
    final String pShell="pShell";
    final String pHome="pHome";
    final String pLimpiarActual="pLimpiarActual";
    final String pGrupUsers="pGrupUsers";
    
    // Strings para ser localizados
    // Todos los Strings estan en:
    //          kemit.ldap.textos.properties
    
    final ResourceBundle rb=ResourceBundle.getBundle("textos");
    
    private String ATT,INTRODUCIR_LOGIN,USUARIO_INCORRECTO,NO_CONEXION,DEMASIADOS_INTENTOS,ERROR_COMUNICACIONES;
    private String RAIZ,USUARIOS,GRUPOS;
    private String COMPROBANDO_ESQUEMA_SAGA,ANYADO_ESQUEMA_SAGA,REINCIANDO_SERVIDOR,CONECTANDO_SERVIDOR,ESQUEMA_SAGA_INCORRECTO,ESQUEMA_SAGA_CORRECTO;
    private String INICIO_SISTEMA,ADMINISTRADOR_LOGIN,SALIENDO_SISTEMA,CANCELAR_LOGIN;
    
    private String RESTAURAR_BCK,REALIZAR_BCK,IMPORTAR_FICHERO,INICIO_BASE_SERIALIZADA,BASE_SERIALIZADA,CANCELAR_BASE_SERIALIZADA,ERROR_BASE_SERIALIZADA;
    private String INICIO_BASE_DESSERIALIZADA,BASE_DESSERIALIZADA,ERROR_BASE_DESSERIALIZADA,MAL_EXTENSION_BCK;
    private String IMPORTAR_FICHERO_OK,IMPORTAR_FICHERO_MAL,CANCELAR_IMPORTAR_FICHERO;
    
    private String RECUPERANDO_USUARIOS;
    
    private java.lang.String FIN_RECUPERANDO_USUARIOS;
    private String RECUPERANDO_GRUPOS,FIN_RECUPERANDO_GRUPOS;
    
    private String NO_HAY_NUEVOS_USUARIOS,GRP_UTIL,BCON_SERVIDOR;
    
    
    private String SI_ADELANTE,NI_HABLAR,PREGUNTA,ESTA_A_PUNTO_DE_BORRAR,ESTA_A_PUNTO_DE_INSERTAR;
    private String OPMAL,OPEXIT,ESTA_A_PUNTO_DE_CANCELAR,REGISTRE_OPERACION,ESCOLLIR,ESTA_A_PUNTO_DE_APLICAR_EN_SERVER;
    
    private String BAJA_USUARIO,BAJA_GRUPO,BAJA_USUARIO_EN_GRUPO,PWD_NO_COINCIDEN,PWD_VACIO;
    
    //String para otros objetos
    
    public String NORMALIZA_ATT,PONE_ATT,ENVIA_AL_SERVER,CREADO_EN_SERVER;
    public String BORRANDO_USUARIO,TAR_FICHERO_USUARIO,ERROR_TAR,BORRANDO_USER_EN_SERVER,ERROR_BORRANDO_USER_EN_SERVER,ERROR_BORRANDO_FICHERO_USUARIO,BORRANDO_FICHERO_USUARIO;
    
    
    public String CREANDO_USUARIO,CREANDO_HOME,ERROR_CREANDO_HOME,COPIANDO_SKEL,ERROR_COPIANDO_SKEL,ERROR_GRABACION_EN_SERVER,ASIGNANDO_DERECHOS,ERROR_ASIGNANDO_DERECHOS;
    
    
    // Fin de los Strings
    
    
    DefaultListModel dlm_new=new DefaultListModel();
    DefaultListModel dlm_borrar=new DefaultListModel();
    DefaultListModel dlm_igual=new DefaultListModel();
    DefaultListModel dlm_gu=new DefaultListModel();
    DefaultListModel dlm_usu=new DefaultListModel();
    
    DefaultComboBoxModel cbGrupos=new DefaultComboBoxModel();
    
    KCheckBoxJList listaUsuariosIgual;
    KCheckBoxJList listaNuevosUsuarios;
    KCheckBoxJList listaUsuariosBorrar;
    KCheckBoxJList lgrupsUsu;
    
    KCheckBoxJList listaUsuarios;
    
    //
    DefaultTreeModel dtm;
    DefaultMutableTreeNode raiz;
    
    DefaultMutableTreeNode nodoGrupos;
    DefaultMutableTreeNode nodoUsuarios;
    
    arbolRenderer ar=new arbolRenderer();
    
    DefaultMutableTreeNode nodoMenu;
    
    GrupoLDAP gdefecto=null;
    GrupoLDAP grp_users=null;
    unixUtil.unixGroup unix_grp_group=null;
    
    int versionLINKAT=1;
    
    UsuarioLDAP g_usu_actual;
    GrupoLDAP g_grupo_actual;
    
    
    /** Creates new form Principal */
    
    public Principal() {
        
        //Locale.setDefault(new Locale("ca"));
        //try { UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());} catch(Exception e) {}
        initSecundarios();
        initComponents();
        initMensages();
        init_dlg();
        init_finales();
        localizeJFileChooser();
        raiz=new DefaultMutableTreeNode(RAIZ);
        nodoUsuarios=new DefaultMutableTreeNode(USUARIOS);
        nodoGrupos=new DefaultMutableTreeNode(GRUPOS);
        
        dtm=new DefaultTreeModel(raiz);
        raiz.add(nodoUsuarios);
        raiz.add(nodoGrupos);
        
        arbol.setModel(dtm);
        arbol.setCellRenderer(ar);
        
        
        mensage(INICIO_SISTEMA);
        
        unixUtil uu=new unixUtil();
        unixUsers=uu.getUnixUsers();
        unixGroups=uu.getUnixGroups();
        
        
        
    }
    
    void init_finales() {
        if (arbol.getRowHeight() <= 0) arbol.setRowHeight(1);
        arbol.setRowHeight(0);
        arbol.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        arbol.addTreeSelectionListener(new arbolSelectionListener(arbol));
        
        // ifUsuariosNuevos
        listaNuevosUsuarios = new KCheckBoxJList();
        JPanel pNU=new JPanel();
        JScrollPane scrollNU=new JScrollPane();
        
        pNU.setLayout(new java.awt.BorderLayout());
        scrollNU.setViewportView((JList)listaNuevosUsuarios);
        pNU.add(scrollNU, java.awt.BorderLayout.CENTER);
        ifUsuariosNuevos.getContentPane().add(pNU, java.awt.BorderLayout.CENTER);
        
        listaNuevosUsuarios.setModel(dlm_new);
        
        // ifUsuariosBorrar
        
        listaUsuariosBorrar = new KCheckBoxJList();
        JPanel pNU1=new JPanel();
        JScrollPane scrollNU1=new JScrollPane();
        
        pNU1.setLayout(new java.awt.BorderLayout());
        scrollNU1.setViewportView((JList)listaUsuariosBorrar);
        pNU1.add(scrollNU1, java.awt.BorderLayout.CENTER);
        ifUsuariosBorrar.getContentPane().add(pNU1, java.awt.BorderLayout.CENTER);
        
        listaUsuariosBorrar.setModel(dlm_borrar);
        
        //ifUsuariosIgual
        
        listaUsuariosIgual = new KCheckBoxJList();
        JPanel pNU2=new JPanel();
        JScrollPane scrollNU2=new JScrollPane();
        
        pNU2.setLayout(new java.awt.BorderLayout());
        scrollNU2.setViewportView((JList)listaUsuariosIgual);
        pNU2.add(scrollNU2, java.awt.BorderLayout.CENTER);
        ifUsuariosIgual.getContentPane().add(pNU2, java.awt.BorderLayout.CENTER);
        
        listaUsuariosIgual.setModel(dlm_igual);
        
        // ifUsuariosEditar
        
        lgrupsUsu = new KCheckBoxJList();
        JScrollPane scrollLUS=new JScrollPane();
        scrollLUS.setViewportView((JList)lgrupsUsu);
        
        java.awt.GridBagConstraints gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ifEditUser.getContentPane().add(scrollLUS, gridBagConstraints);
        
        
        lgrupsUsu.setModel(dlm_gu);
        listGruposAlta.setModel(dlm_gu);
        
        //
        listaUsuarios = new KCheckBoxJList();
        JPanel pNU3=new JPanel();
        JScrollPane scrollNU3=new JScrollPane();
        
        pNU3.setLayout(new java.awt.BorderLayout());
        scrollNU3.setViewportView((JList)listaUsuarios);
        pNU3.add(scrollNU3, java.awt.BorderLayout.CENTER);
        ifEditGroup.getContentPane().add(pNU3, java.awt.BorderLayout.CENTER);
        
        listaUsuarios.setModel(dlm_usu);
        
        
        
        //escritorio.setDragMode(JDesktopPane.LIVE_DRAG_MODE);
        
        ifUsuariosNuevos.pack();
        ifUsuariosBorrar.pack();
        ifUsuariosIgual.pack();
        ifMensages.setSize(new Dimension(500,300));
        ifUsuariosNuevos.setSize(new Dimension(500,400));
        ifUsuariosBorrar.setSize(new Dimension(500,400));
        ifUsuariosIgual.setSize(new Dimension(500,400));
        
        ifEditGroup.pack();
        
        
        escritorio.add(ifMensages,JLayeredPane.DEFAULT_LAYER);
        escritorio.add(ifUsuariosNuevos,JLayeredPane.DEFAULT_LAYER);
        escritorio.add(ifUsuariosBorrar,JLayeredPane.DEFAULT_LAYER);
        escritorio.add(ifUsuariosIgual,JLayeredPane.DEFAULT_LAYER);
        
        ifEditUser.setVisible(false);
        ifEditGroup.setVisible(false);
        
        //ifEditUser.setSize(new Dimension(500,300));
        ifEditUser.pack();
        ifEditUser.setLocation(new Point(75,75));
        //ifEditGroup.setSize(new Dimension(400,130));
        ifEditGroup.pack();
        ifEditGroup.setLocation(new Point(105,105));
        
        escritorio.add(ifEditUser,JLayeredPane.DEFAULT_LAYER);
        escritorio.add(ifEditGroup,JLayeredPane.DEFAULT_LAYER);
    }
    
    void init_dlg() {
        
        Dimension d;
        int w,h;
        
        dlgLogin.pack();
        d=dlgLogin.getSize();
        w=(int) (screenSize.width-d.getWidth())/2;
        h=(int) (screenSize.height-d.getHeight())/2;
        dlgLogin.setLocation(w,h);
        
        
        dlgAvances.pack();
        d=dlgAvances.getSize();
        w=(int) (screenSize.width-d.getWidth())/2;
        h=(int) (screenSize.height-d.getHeight())/2;
        dlgAvances.setLocation(w,h);
        
        
        dlgPreferencias.pack();
        d=dlgPreferencias.getSize();
        w=(int) (screenSize.width-d.getWidth())/2;
        h=(int) (screenSize.height-d.getHeight())/2;
        dlgPreferencias.setLocation(w,h);
        
        
        dlgAbout.pack();
        d=dlgAbout.getSize();
        w=(int) (screenSize.width-d.getWidth())/2;
        h=(int) (screenSize.height-d.getHeight())/2;
        dlgAbout.setLocation(w,h);
        
        dlgGrupo.pack();
        d=dlgGrupo.getSize();
        w=(int) (screenSize.width-d.getWidth())/2;
        h=(int) (screenSize.height-d.getHeight())/2;
        dlgGrupo.setLocation(w,h);
        
        
        
        
    }
    
    void initSecundarios() {
        screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        URL imageURL = Principal.class.getResource("/imagenes/ico_linkat.gif");
        this.setIconImage(Toolkit.getDefaultToolkit().createImage(imageURL));
    }
    
    void initMensages() {
        
        ATT=rb.getString("ATT");
        INTRODUCIR_LOGIN=rb.getString("INTRODUCIR_LOGIN");
        USUARIO_INCORRECTO=rb.getString("USUARIO_INCORRECTO");
        ERROR_COMUNICACIONES=rb.getString("ERROR_COMUNICACIONES");
        DEMASIADOS_INTENTOS=rb.getString("DEMASIADOS_INTENTOS");
        RAIZ=rb.getString("RAIZ");
        USUARIOS=rb.getString("USUARIOS");
        GRUPOS=rb.getString("GRUPOS");
        
        COMPROBANDO_ESQUEMA_SAGA=rb.getString("COMPROBANDO_ESQUEMA_SAGA");
        ANYADO_ESQUEMA_SAGA=rb.getString("ANYADO_ESQUEMA_SAGA");
        REINCIANDO_SERVIDOR=rb.getString("REINCIANDO_SERVIDOR");
        CONECTANDO_SERVIDOR=rb.getString("CONECTANDO_SERVIDOR");
        ESQUEMA_SAGA_INCORRECTO=rb.getString("ESQUEMA_SAGA_INCORRECTO");
        ESQUEMA_SAGA_CORRECTO=rb.getString("ESQUEMA_SAGA_CORRECTO");
        
        
        INICIO_SISTEMA=rb.getString("INICIO_SISTEMA");
        CANCELAR_LOGIN=rb.getString("CANCELAR_LOGIN");
        ADMINISTRADOR_LOGIN=rb.getString("ADMINISTRADOR_LOGIN");
        SALIENDO_SISTEMA=rb.getString("SALIENDO_SISTEMA");
        
        RESTAURAR_BCK=rb.getString("RESTAURAR_BCK");
        REALIZAR_BCK=rb.getString("REALIZAR_BCK");
        IMPORTAR_FICHERO=rb.getString("IMPORTAR_FICHERO");
        INICIO_BASE_SERIALIZADA=rb.getString("INICIO_BASE_SERIALIZADA");
        BASE_SERIALIZADA=rb.getString("BASE_SERIALIZADA");
        CANCELAR_BASE_SERIALIZADA=rb.getString("CANCELAR_BASE_SERIALIZADA");
        CANCELAR_IMPORTAR_FICHERO=rb.getString("CANCELAR_IMPORTAR_FICHERO");
        IMPORTAR_FICHERO_OK=rb.getString("IMPORTAR_FICHERO_OK");
        IMPORTAR_FICHERO_MAL=rb.getString("IMPORTAR_FICHERO_MAL");
        
        
        ERROR_BASE_SERIALIZADA=rb.getString("ERROR_BASE_SERIALIZADA");
        INICIO_BASE_DESSERIALIZADA=rb.getString("INICIO_BASE_DESSERIALIZADA");
        BASE_DESSERIALIZADA=rb.getString("BASE_DESSERIALIZADA");
        ERROR_BASE_DESSERIALIZADA=rb.getString("ERROR_BASE_DESSERIALIZADA");
        MAL_EXTENSION_BCK=rb.getString("MAL_EXTENSION_BCK");
        
        RECUPERANDO_USUARIOS=rb.getString("RECUPERANDO_USUARIOS");
        FIN_RECUPERANDO_USUARIOS=rb.getString("FIN_RECUPERANDO_USUARIOS");
        RECUPERANDO_GRUPOS=rb.getString("RECUPERANDO_GRUPOS");
        FIN_RECUPERANDO_GRUPOS=rb.getString("FIN_RECUPERANDO_GRUPOS");
        
        NO_HAY_NUEVOS_USUARIOS=rb.getString("NO_HAY_NUEVOS_USUARIOS");
        
        
        SI_ADELANTE=rb.getString("SI_ADELANTE");
        NI_HABLAR=rb.getString("NI_HABLAR");
        PREGUNTA=rb.getString("PREGUNTA");
        ESTA_A_PUNTO_DE_BORRAR=rb.getString("ESTA_A_PUNTO_DE_BORRAR");
        ESTA_A_PUNTO_DE_INSERTAR=rb.getString("ESTA_A_PUNTO_DE_INSERTAR");
        OPEXIT=rb.getString("OPEXIT");
        OPMAL=rb.getString("OPMAL");
        ESTA_A_PUNTO_DE_CANCELAR=rb.getString("ESTA_A_PUNTO_DE_CANCELAR");
        
        ESCOLLIR=rb.getString("ESCOLLIR");
        REGISTRE_OPERACION=rb.getString("REGISTRE_OPERACION");
        
        ESTA_A_PUNTO_DE_APLICAR_EN_SERVER=rb.getString("ESTA_A_PUNTO_DE_APLICAR_EN_SERVER");
        GRP_UTIL=rb.getString("GRP_UTIL");
        BCON_SERVIDOR=rb.getString("BCON_SERVIDOR");
        
        NORMALIZA_ATT=rb.getString("NORMALIZA_ATT");
        PONE_ATT=rb.getString("PONE_ATT");
        ENVIA_AL_SERVER=rb.getString("ENVIA_AL_SERVER");
        CREADO_EN_SERVER=rb.getString("CREADO_EN_SERVER");
        
        BORRANDO_USUARIO=rb.getString("BORRANDO_USUARIO");
        TAR_FICHERO_USUARIO=rb.getString("TAR_FICHERO_USUARIO");
        ERROR_TAR=rb.getString("ERROR_TAR");
        BORRANDO_USER_EN_SERVER=rb.getString("BORRANDO_USER_EN_SERVER");
        ERROR_BORRANDO_USER_EN_SERVER=rb.getString("ERROR_BORRANDO_USER_EN_SERVER");
        ERROR_BORRANDO_FICHERO_USUARIO=rb.getString("ERROR_BORRANDO_FICHERO_USUARIO");
        BORRANDO_FICHERO_USUARIO=rb.getString("BORRANDO_FICHERO_USUARIO");
        
        
        CREANDO_USUARIO=rb.getString("CREANDO_USUARIO");
        CREANDO_HOME=rb.getString("CREANDO_HOME");
        ERROR_CREANDO_HOME=rb.getString("ERROR_CREANDO_HOME");
        COPIANDO_SKEL=rb.getString("COPIANDO_SKEL");
        ERROR_COPIANDO_SKEL=rb.getString("ERROR_COPIANDO_SKEL");
        ERROR_GRABACION_EN_SERVER=rb.getString("ERROR_GRABACION_EN_SERVER");
        ASIGNANDO_DERECHOS=rb.getString("ASIGNANDO_DERECHOS");
        ERROR_ASIGNANDO_DERECHOS=rb.getString("ERROR_ASIGNANDO_DERECHOS");
        
        BAJA_USUARIO=rb.getString("BAJA_USUARIO");
        BAJA_GRUPO=rb.getString("BAJA_GRUPO");
        BAJA_USUARIO_EN_GRUPO=rb.getString("BAJA_USUARIO_EN_GRUPO");
        
        PWD_NO_COINCIDEN=rb.getString("PWD_NO_COINCIDEN");
        PWD_VACIO=rb.getString("PWD_VACIO");
        
    }
    
    public void setVisible(boolean b) {
        if (b) {
            Dimension d=yo.getSize();
            //Dimension d=new Dimension(800,600);
            int w=(int) (screenSize.width-d.getWidth())/2;
            int h=(int) (screenSize.height-d.getHeight())/2;
            yo.setLocation(w,h);
            
        }
        super.setVisible(b);
    }
    
    void login() {
        dlgLogin.setVisible(true);
        dlgLogin.toFront();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        dlgLogin = new JDialog(this,"",false);
        jLabel2 = new javax.swing.JLabel();
        password = new javax.swing.JPasswordField();
        jLabel19 = new javax.swing.JLabel();
        txtUserAdmin1 = new javax.swing.JTextField();
        txtDC1 = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        bCancelLogin = new javax.swing.JButton();
        bEntrarLogin = new javax.swing.JButton();
        ifUsuariosNuevos = new javax.swing.JInternalFrame();
        pBotonesNU = new javax.swing.JPanel();
        binsertarNU = new javax.swing.JButton();
        bSalirNU = new javax.swing.JButton();
        bMarcarUN = new javax.swing.JButton();
        bDesmarcarUN = new javax.swing.JButton();
        ifMensages = new javax.swing.JInternalFrame();
        jScrollPane1 = new javax.swing.JScrollPane();
        msgTxtArea = new javax.swing.JTextArea();
        pBotones = new javax.swing.JPanel();
        bmsgSalir = new javax.swing.JButton();
        bGuardarLog = new javax.swing.JButton();
        bBorrarMsg = new javax.swing.JButton();
        ifUsuariosBorrar = new javax.swing.JInternalFrame();
        pBotonesNU1 = new javax.swing.JPanel();
        bBorrarU = new javax.swing.JButton();
        bSalirUB = new javax.swing.JButton();
        bMarcarUB = new javax.swing.JButton();
        bDesmarcarUB = new javax.swing.JButton();
        ifUsuariosIgual = new javax.swing.JInternalFrame();
        pBotonesNU2 = new javax.swing.JPanel();
        bSalirUI = new javax.swing.JButton();
        bPasasB = new javax.swing.JButton();
        bMarcarUI = new javax.swing.JButton();
        bDesmarcarUI = new javax.swing.JButton();
        dlgAvances = new javax.swing.JDialog();
        barra = new javax.swing.JProgressBar();
        jScrollPane2 = new javax.swing.JScrollPane();
        msgOperaciones = new javax.swing.JTextArea();
        dlgPreferencias = new javax.swing.JDialog();
        listaAlgoritmos = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        dirGuargar = new javax.swing.JLabel();
        bDirDef = new javax.swing.JButton();
        chDebug = new javax.swing.JCheckBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        chConservarHome = new javax.swing.JCheckBox();
        chBorraGrpUsu = new javax.swing.JCheckBox();
        jPanel6 = new javax.swing.JPanel();
        bGrabarPref = new javax.swing.JButton();
        bCancelarPref = new javax.swing.JButton();
        bDefectos = new javax.swing.JButton();
        bSalirPref = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        txtUserAdmin = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        txtDC = new javax.swing.JTextField();
        txtShell = new javax.swing.JTextField();
        txtHome = new javax.swing.JTextField();
        chGrupUsers = new javax.swing.JCheckBox();
        dlgAbout = new javax.swing.JDialog();
        imgKemit = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        bsalirAbout = new javax.swing.JButton();
        ifEditUser = new javax.swing.JInternalFrame();
        txtNomUsu = new javax.swing.JTextField();
        txtUID = new javax.swing.JTextField();
        txtPwd1 = new javax.swing.JPasswordField();
        txtPwd2 = new javax.swing.JPasswordField();
        txtHomeUsu = new javax.swing.JTextField();
        txtShellUsu = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        bAUsu = new javax.swing.JButton();
        bMUsu = new javax.swing.JButton();
        bSEG1 = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        txtNOM = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        txtCNOM = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        txtSagaID = new javax.swing.JTextField();
        cbGrupPrincipal = new javax.swing.JComboBox();
        jLabel21 = new javax.swing.JLabel();
        ifEditGroup = new javax.swing.JInternalFrame();
        jPanel8 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        txtNomGrup = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        bAG = new javax.swing.JButton();
        bMUsu1 = new javax.swing.JButton();
        bSEG = new javax.swing.JButton();
        bMarcarUI1 = new javax.swing.JButton();
        bDesmarcarUI1 = new javax.swing.JButton();
        dlgGrupo = new javax.swing.JDialog();
        scrollG = new javax.swing.JScrollPane();
        listGruposAlta = new javax.swing.JList();
        jPanel3 = new javax.swing.JPanel();
        bgrupdefecto = new javax.swing.JButton();
        bgrupsel = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        kCheckBoxJList1 = new kemit.component.KCheckBoxJList();
        pmUsu = new javax.swing.JPopupMenu();
        pEditarN = new javax.swing.JMenuItem();
        pBorrarN = new javax.swing.JMenuItem();
        pmsg = new javax.swing.JPanel();
        lineaMsg = new javax.swing.JLabel();
        jSplitPane1 = new javax.swing.JSplitPane();
        izqPanel = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        txtBusqueda = new javax.swing.JTextField();
        bBuscar = new javax.swing.JButton();
        scollArbol = new javax.swing.JScrollPane();
        arbol = new javax.swing.JTree();
        derPanel = new javax.swing.JPanel();
        escritorio = new javax.swing.JDesktopPane();
        toolBar = new javax.swing.JToolBar();
        bImportar = new javax.swing.JButton();
        bRefrescar = new javax.swing.JButton();
        bCancelarOperaciones = new javax.swing.JButton();
        bCascade = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        bSalir = new javax.swing.JButton();
        jMenuBar = new javax.swing.JMenuBar();
        mnuFichero = new javax.swing.JMenu();
        mnuPreferncias = new javax.swing.JMenuItem();
        mnuVersion = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        mnuSalir = new javax.swing.JMenuItem();
        mnuOperaciones = new javax.swing.JMenu();
        mnuImportar = new javax.swing.JMenuItem();
        mnuBackUp = new javax.swing.JMenu();
        mnuCopia = new javax.swing.JMenuItem();
        mnuRestaura = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        mnuEstructuraAServer = new javax.swing.JMenuItem();
        mnuVentanas = new javax.swing.JMenu();
        mnucbMensages = new javax.swing.JCheckBoxMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        mnucbNU = new javax.swing.JCheckBoxMenuItem();
        mnucbUaB = new javax.swing.JCheckBoxMenuItem();
        mnucbUQNC = new javax.swing.JCheckBoxMenuItem();

        dlgLogin.getContentPane().setLayout(new java.awt.GridBagLayout());

        dlgLogin.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        dlgLogin.setTitle(rb.getString("ID_USUARIO"));
        dlgLogin.setFocusTraversalPolicy(new focusLogin());
        dlgLogin.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                dlgLoginWindowClosing(evt);
            }
        });

        jLabel2.setText(rb.getString("CLAU"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgLogin.getContentPane().add(jLabel2, gridBagConstraints);

        password.setColumns(20);
        password.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                passwordActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgLogin.getContentPane().add(password, gridBagConstraints);

        jLabel19.setText(rb.getString("USUARI_ADM"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 5, 5);
        dlgLogin.getContentPane().add(jLabel19, gridBagConstraints);

        txtUserAdmin1.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        dlgLogin.getContentPane().add(txtUserAdmin1, gridBagConstraints);

        txtDC1.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgLogin.getContentPane().add(txtDC1, gridBagConstraints);

        jLabel20.setText(rb.getString("DOMINI_LDAP"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgLogin.getContentPane().add(jLabel20, gridBagConstraints);

        jPanel7.setLayout(new java.awt.GridLayout(2, 1));

        bCancelLogin.setText(rb.getString("CANCELAR"));
        bCancelLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelLoginActionPerformed(evt);
            }
        });

        jPanel7.add(bCancelLogin);

        bEntrarLogin.setText(rb.getString("ENTRAR"));
        bEntrarLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bEntrarLoginActionPerformed(evt);
            }
        });
        bEntrarLogin.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                bEntrarLoginKeyReleased(evt);
            }
        });

        jPanel7.add(bEntrarLogin);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 5, 3);
        dlgLogin.getContentPane().add(jPanel7, gridBagConstraints);

        ifUsuariosNuevos.setIconifiable(true);
        ifUsuariosNuevos.setResizable(true);
        ifUsuariosNuevos.setTitle(rb.getString("NUEVOS_USUARIOS"));
        ifUsuariosNuevos.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_into.png")));
        try {
            ifUsuariosNuevos.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        ifUsuariosNuevos.addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
                ifUsuariosNuevosInternalFrameIconified(evt);
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        binsertarNU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/certificate24.png")));
        binsertarNU.setText(rb.getString("B_PROCESAR_LISTA"));
        binsertarNU.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                binsertarNUActionPerformed(evt);
            }
        });

        pBotonesNU.add(binsertarNU);

        bSalirNU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bSalirNU.setText(rb.getString("BSALIR"));
        bSalirNU.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirNUActionPerformed(evt);
            }
        });

        pBotonesNU.add(bSalirNU);

        bMarcarUN.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMarcarUN.setToolTipText("Marcar tot");
        bMarcarUN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMarcarUNActionPerformed(evt);
            }
        });

        pBotonesNU.add(bMarcarUN);

        bDesmarcarUN.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete.png")));
        bDesmarcarUN.setToolTipText("Desmarcar tot");
        bDesmarcarUN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDesmarcarUNActionPerformed(evt);
            }
        });

        pBotonesNU.add(bDesmarcarUN);

        ifUsuariosNuevos.getContentPane().add(pBotonesNU, java.awt.BorderLayout.SOUTH);

        ifMensages.getContentPane().setLayout(new java.awt.GridBagLayout());

        ifMensages.setIconifiable(true);
        ifMensages.setResizable(true);
        ifMensages.setTitle(rb.getString("TIT_MSG"));
        ifMensages.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/policeman_usa.png")));
        try {
            ifMensages.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        msgTxtArea.setColumns(20);
        msgTxtArea.setRows(5);
        jScrollPane1.setViewportView(msgTxtArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ifMensages.getContentPane().add(jScrollPane1, gridBagConstraints);

        bmsgSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bmsgSalir.setText(rb.getString("BSALIR"));
        bmsgSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bmsgSalirActionPerformed(evt);
            }
        });

        pBotones.add(bmsgSalir);

        bGuardarLog.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/history2.png")));
        bGuardarLog.setText(rb.getString("GURARDAR_DISK"));
        bGuardarLog.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bGuardarLogActionPerformed(evt);
            }
        });

        pBotones.add(bGuardarLog);

        bBorrarMsg.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/note_delete.png")));
        bBorrarMsg.setText(rb.getString("LIMPIAR"));
        bBorrarMsg.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bBorrarMsgActionPerformed(evt);
            }
        });

        pBotones.add(bBorrarMsg);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        ifMensages.getContentPane().add(pBotones, gridBagConstraints);

        ifUsuariosBorrar.getContentPane().setLayout(new BorderLayout());
        ifUsuariosBorrar.setIconifiable(true);
        ifUsuariosBorrar.setResizable(true);
        ifUsuariosBorrar.setTitle(rb.getString("TIT_USUARIS_BORRAR"));
        ifUsuariosBorrar.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_delete.png")));
        ifUsuariosBorrar.addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
                ifUsuariosBorrarInternalFrameIconified(evt);
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        bBorrarU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/garbage_empty.png")));
        bBorrarU.setText(rb.getString("B_ESBORRAR"));
        bBorrarU.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bBorrarUActionPerformed(evt);
            }
        });

        pBotonesNU1.add(bBorrarU);

        bSalirUB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bSalirUB.setText("Sortir");
        bSalirUB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirUBActionPerformed(evt);
            }
        });

        pBotonesNU1.add(bSalirUB);

        bMarcarUB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMarcarUB.setToolTipText(rb.getString("B_MARCAR_TODOS"));
        bMarcarUB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMarcarUBActionPerformed(evt);
            }
        });

        pBotonesNU1.add(bMarcarUB);

        bDesmarcarUB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete.png")));
        bDesmarcarUB.setToolTipText(rb.getString("B_DESMARCAR"));
        bDesmarcarUB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDesmarcarUBActionPerformed(evt);
            }
        });

        pBotonesNU1.add(bDesmarcarUB);

        ifUsuariosBorrar.getContentPane().add(pBotonesNU1, java.awt.BorderLayout.SOUTH);

        ifUsuariosIgual.setIconifiable(true);
        ifUsuariosIgual.setResizable(true);
        ifUsuariosIgual.setTitle(rb.getString("TIT_USUARIOS_IGUAL"));
        ifUsuariosIgual.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_information.png")));
        ifUsuariosIgual.setNormalBounds(new java.awt.Rectangle(0, 0, 90, 90));
        try {
            ifUsuariosIgual.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        ifUsuariosIgual.addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
                ifUsuariosIgualInternalFrameIconified(evt);
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        pBotonesNU2.setLayout(new java.awt.GridBagLayout());

        bSalirUI.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bSalirUI.setText("Sortir");
        bSalirUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirUIActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        pBotonesNU2.add(bSalirUI, gridBagConstraints);

        bPasasB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/garbage_empty.png")));
        bPasasB.setText(rb.getString("PASAR_A_BORRABLES"));
        bPasasB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bPasasBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        pBotonesNU2.add(bPasasB, gridBagConstraints);

        bMarcarUI.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMarcarUI.setToolTipText(rb.getString("B_MARCAR_TODOS"));
        bMarcarUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMarcarUIActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        pBotonesNU2.add(bMarcarUI, gridBagConstraints);

        bDesmarcarUI.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete.png")));
        bDesmarcarUI.setToolTipText(rb.getString("B_DESMARCAR"));
        bDesmarcarUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDesmarcarUIActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 2, 0);
        pBotonesNU2.add(bDesmarcarUI, gridBagConstraints);

        ifUsuariosIgual.getContentPane().add(pBotonesNU2, java.awt.BorderLayout.SOUTH);

        dlgAvances.setTitle(rb.getString("OPERACIONES"));
        dlgAvances.setModal(true);
        dlgAvances.setResizable(false);
        barra.setValue(10);
        barra.setStringPainted(true);

        msgOperaciones.setColumns(20);
        msgOperaciones.setRows(5);
        jScrollPane2.setViewportView(msgOperaciones);

        org.jdesktop.layout.GroupLayout dlgAvancesLayout = new org.jdesktop.layout.GroupLayout(dlgAvances.getContentPane());
        dlgAvances.getContentPane().setLayout(dlgAvancesLayout);
        dlgAvancesLayout.setHorizontalGroup(
            dlgAvancesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(dlgAvancesLayout.createSequentialGroup()
                .addContainerGap()
                .add(dlgAvancesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, barra, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
                .addContainerGap())
        );
        dlgAvancesLayout.setVerticalGroup(
            dlgAvancesLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, dlgAvancesLayout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(barra, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        dlgPreferencias.getContentPane().setLayout(new java.awt.GridBagLayout());

        dlgPreferencias.setTitle(rb.getString("MNU_PREFS"));
        dlgPreferencias.setModal(true);
        dlgPreferencias.setResizable(false);
        listaAlgoritmos.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PLAIN", "LINUX", "SHA", "MD5", "SSHA", "SMD5" }));
        listaAlgoritmos.setSelectedIndex(1);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(listaAlgoritmos, gridBagConstraints);

        jLabel1.setText(rb.getString("METODO_ENCRIPTACION"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel1, gridBagConstraints);

        jLabel3.setText(rb.getString("DIR_USUARIOS"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel3, gridBagConstraints);

        dirGuargar.setBackground(new java.awt.Color(255, 255, 255));
        dirGuargar.setText("/root");
        dirGuargar.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        dirGuargar.setOpaque(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        dlgPreferencias.getContentPane().add(dirGuargar, gridBagConstraints);

        bDirDef.setText("...");
        bDirDef.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDirDefActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        dlgPreferencias.getContentPane().add(bDirDef, gridBagConstraints);

        chDebug.setText(rb.getString("DEBUG"));
        chDebug.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chDebug.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chDebugItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(chDebug, gridBagConstraints);

        jLabel4.setText(rb.getString("SHELL_DEFECTO"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel4, gridBagConstraints);

        jLabel5.setText(rb.getString("HOME_DEFECTO"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel5, gridBagConstraints);

        chConservarHome.setSelected(true);
        chConservarHome.setText(rb.getString("CONSERVAR_INFORMACION"));
        chConservarHome.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chConservarHome.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chConservarHomeItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        dlgPreferencias.getContentPane().add(chConservarHome, gridBagConstraints);

        chBorraGrpUsu.setText(rb.getString("BORRAGRPYUSU_ESCTRUCTURA"));
        chBorraGrpUsu.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(chBorraGrpUsu, gridBagConstraints);

        bGrabarPref.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bGrabarPref.setText(rb.getString("BGRABAR"));
        bGrabarPref.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bGrabarPrefActionPerformed(evt);
            }
        });

        jPanel6.add(bGrabarPref);

        bCancelarPref.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete.png")));
        bCancelarPref.setText(rb.getString("CANCELAR"));
        bCancelarPref.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelarPrefActionPerformed(evt);
            }
        });

        jPanel6.add(bCancelarPref);

        bDefectos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/lifebelt.png")));
        bDefectos.setText(rb.getString("DEFECTOS"));
        bDefectos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDefectosActionPerformed(evt);
            }
        });

        jPanel6.add(bDefectos);

        bSalirPref.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/exit.png")));
        bSalirPref.setText(rb.getString("BSALIR"));
        bSalirPref.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirPrefActionPerformed(evt);
            }
        });

        jPanel6.add(bSalirPref);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        dlgPreferencias.getContentPane().add(jPanel6, gridBagConstraints);

        jLabel17.setText(rb.getString("USUARI_ADM"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel17, gridBagConstraints);

        txtUserAdmin.setColumns(20);
        txtUserAdmin.setText("Administrador");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        dlgPreferencias.getContentPane().add(txtUserAdmin, gridBagConstraints);

        jLabel18.setText(rb.getString("DOMINI_LDAP"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        dlgPreferencias.getContentPane().add(jLabel18, gridBagConstraints);

        txtDC.setColumns(20);
        txtDC.setText("intracentre");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(txtDC, gridBagConstraints);

        txtShell.setColumns(25);
        txtShell.setText("/bin/bash");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(txtShell, gridBagConstraints);

        txtHome.setColumns(25);
        txtHome.setText("/home");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(txtHome, gridBagConstraints);

        chGrupUsers.setText(rb.getString("ANYADE_AL_USERS"));
        chGrupUsers.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chGrupUsers.setSelected(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        dlgPreferencias.getContentPane().add(chGrupUsers, gridBagConstraints);

        dlgAbout.setTitle(rb.getString("MNU_VERSION"));
        dlgAbout.setModal(true);
        dlgAbout.setResizable(false);
        imgKemit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/GUS_def_01.png")));
        dlgAbout.getContentPane().add(imgKemit, java.awt.BorderLayout.NORTH);

        bsalirAbout.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/exit.png")));
        bsalirAbout.setText(rb.getString("BSALIR"));
        bsalirAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bsalirAboutActionPerformed(evt);
            }
        });

        jPanel1.add(bsalirAbout);

        dlgAbout.getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        ifEditUser.getContentPane().setLayout(new java.awt.GridBagLayout());

        ifEditUser.setIconifiable(true);
        ifEditUser.setResizable(true);
        ifEditUser.setTitle(rb.getString("TITIFEDITUSU"));
        ifEditUser.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_information.png")));
        try {
            ifEditUser.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        ifEditUser.setVisible(true);
        ifEditUser.addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
                ifEditUserInternalFrameIconified(evt);
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        txtNomUsu.setColumns(20);
        txtNomUsu.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        ifEditUser.getContentPane().add(txtNomUsu, gridBagConstraints);

        txtUID.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtUID, gridBagConstraints);

        txtPwd1.setColumns(15);
        txtPwd1.setText("jPasswordField1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtPwd1, gridBagConstraints);

        txtPwd2.setColumns(15);
        txtPwd2.setText("jPasswordField2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtPwd2, gridBagConstraints);

        txtHomeUsu.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtHomeUsu, gridBagConstraints);

        txtShellUsu.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtShellUsu, gridBagConstraints);

        jLabel7.setText(rb.getString("NOM_USU"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel7, gridBagConstraints);

        jLabel8.setText(rb.getString("SECONDARY_GROUPS"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        ifEditUser.getContentPane().add(jLabel8, gridBagConstraints);

        jLabel9.setText(rb.getString("UID"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel9, gridBagConstraints);

        jLabel10.setText(rb.getString("PASS"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel10, gridBagConstraints);

        jLabel11.setText(rb.getString("HOME_USUARI"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel11, gridBagConstraints);

        jLabel12.setText(rb.getString("SHELL_USUARI"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel12, gridBagConstraints);

        bAUsu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/add.png")));
        bAUsu.setText(rb.getString("AUSU"));
        bAUsu.setToolTipText("");
        bAUsu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bAUsuActionPerformed(evt);
            }
        });

        jPanel2.add(bAUsu);

        bMUsu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMUsu.setText(rb.getString("MUSU"));
        bMUsu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMUsuActionPerformed(evt);
            }
        });

        jPanel2.add(bMUsu);

        bSEG1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bSEG1.setText(rb.getString("BSALIR"));
        bSEG1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSEG1ActionPerformed(evt);
            }
        });

        jPanel2.add(bSEG1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 5;
        ifEditUser.getContentPane().add(jPanel2, gridBagConstraints);

        jLabel13.setText(rb.getString("NOM"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel13, gridBagConstraints);

        txtNOM.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtNOM, gridBagConstraints);

        jLabel14.setText(rb.getString("COGNOMS"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel14, gridBagConstraints);

        txtCNOM.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtCNOM, gridBagConstraints);

        jLabel15.setText(rb.getString("SAGAID"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel15, gridBagConstraints);

        txtSagaID.setColumns(10);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(txtSagaID, gridBagConstraints);

        cbGrupPrincipal.setModel(cbGrupos);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        ifEditUser.getContentPane().add(cbGrupPrincipal, gridBagConstraints);

        jLabel21.setText(rb.getString("GRUP_PINCIPAL"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        ifEditUser.getContentPane().add(jLabel21, gridBagConstraints);

        ifEditGroup.setIconifiable(true);
        ifEditGroup.setMaximizable(true);
        ifEditGroup.setResizable(true);
        ifEditGroup.setTitle(rb.getString("TITIFEDITGRUO"));
        ifEditGroup.setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/businessmen24.png")));
        try {
            ifEditGroup.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        ifEditGroup.setVisible(true);
        ifEditGroup.addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
                ifEditGroupInternalFrameIconified(evt);
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        jLabel6.setText(rb.getString("NOM_GRUP"));
        jPanel8.add(jLabel6);

        txtNomGrup.setColumns(20);
        jPanel8.add(txtNomGrup);

        ifEditGroup.getContentPane().add(jPanel8, java.awt.BorderLayout.NORTH);

        bAG.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/add.png")));
        bAG.setText(rb.getString("AGRUP"));
        bAG.setToolTipText("");
        bAG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bAGActionPerformed(evt);
            }
        });

        jPanel9.add(bAG);

        bMUsu1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMUsu1.setText(rb.getString("MUSU"));
        bMUsu1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMUsu1ActionPerformed(evt);
            }
        });

        jPanel9.add(bMUsu1);

        bSEG.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_stop.png")));
        bSEG.setText(rb.getString("BSALIR"));
        bSEG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSEGActionPerformed(evt);
            }
        });

        jPanel9.add(bSEG);

        bMarcarUI1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/check.png")));
        bMarcarUI1.setToolTipText(rb.getString("B_MARCAR_TODOS"));
        bMarcarUI1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMarcarUI1ActionPerformed(evt);
            }
        });

        jPanel9.add(bMarcarUI1);

        bDesmarcarUI1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete.png")));
        bDesmarcarUI1.setToolTipText(rb.getString("B_DESMARCAR"));
        bDesmarcarUI1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDesmarcarUI1ActionPerformed(evt);
            }
        });

        jPanel9.add(bDesmarcarUI1);

        ifEditGroup.getContentPane().add(jPanel9, java.awt.BorderLayout.SOUTH);

        dlgGrupo.setTitle(rb.getString("ATT"));
        dlgGrupo.setModal(true);
        listGruposAlta.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        scrollG.setViewportView(listGruposAlta);

        dlgGrupo.getContentPane().add(scrollG, java.awt.BorderLayout.CENTER);

        bgrupdefecto.setText(rb.getString("NUEVOS_USUARIOS_A_GRP_DEFECTO"));
        bgrupdefecto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bgrupdefectoActionPerformed(evt);
            }
        });

        jPanel3.add(bgrupdefecto);

        bgrupsel.setText(rb.getString("NUEVOS_USUARIOS_A_GRP_SEL"));
        bgrupsel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bgrupselActionPerformed(evt);
            }
        });

        jPanel3.add(bgrupsel);

        dlgGrupo.getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

        jLabel16.setText(rb.getString("DONDE_NUEVOS_USUARIOS"));
        jPanel4.add(jLabel16);

        dlgGrupo.getContentPane().add(jPanel4, java.awt.BorderLayout.NORTH);

        kCheckBoxJList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane3.setViewportView(kCheckBoxJList1);

        pEditarN.setText(rb.getString("PMUSUARIOS_EDITA"));
        pEditarN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pEditarNActionPerformed(evt);
            }
        });

        pmUsu.add(pEditarN);

        pBorrarN.setText(rb.getString("BUSU"));
        pBorrarN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pBorrarNActionPerformed(evt);
            }
        });

        pmUsu.add(pBorrarN);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(rb.getString("TIT_MAIN"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        lineaMsg.setText(" ");

        org.jdesktop.layout.GroupLayout pmsgLayout = new org.jdesktop.layout.GroupLayout(pmsg);
        pmsg.setLayout(pmsgLayout);
        pmsgLayout.setHorizontalGroup(
            pmsgLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(lineaMsg)
        );
        pmsgLayout.setVerticalGroup(
            pmsgLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(lineaMsg)
        );
        getContentPane().add(pmsg, java.awt.BorderLayout.SOUTH);

        jSplitPane1.setDividerLocation(190);
        jSplitPane1.setContinuousLayout(true);
        jSplitPane1.setOneTouchExpandable(true);
        izqPanel.setLayout(new java.awt.BorderLayout());

        izqPanel.setPreferredSize(new java.awt.Dimension(130, 400));
        jPanel5.setLayout(new java.awt.BorderLayout());

        txtBusqueda.setColumns(10);
        txtBusqueda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtBusquedaActionPerformed(evt);
            }
        });

        jPanel5.add(txtBusqueda, java.awt.BorderLayout.CENTER);

        bBuscar.setText("?");
        bBuscar.setToolTipText(rb.getString("BUSCAR_USUARIOS"));
        bBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bBuscarActionPerformed(evt);
            }
        });

        jPanel5.add(bBuscar, java.awt.BorderLayout.EAST);

        izqPanel.add(jPanel5, java.awt.BorderLayout.SOUTH);

        arbol.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                arbolMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                arbolMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                arbolMouseReleased(evt);
            }
        });

        scollArbol.setViewportView(arbol);

        izqPanel.add(scollArbol, java.awt.BorderLayout.CENTER);

        jSplitPane1.setLeftComponent(izqPanel);

        derPanel.setLayout(new java.awt.BorderLayout());

        escritorio.setMinimumSize(new java.awt.Dimension(220, 220));
        derPanel.add(escritorio, java.awt.BorderLayout.CENTER);

        jSplitPane1.setRightComponent(derPanel);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        bImportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_up.png")));
        bImportar.setToolTipText(rb.getString("MNU_IMP_FICHERO"));
        bImportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bImportarActionPerformed(evt);
            }
        });

        toolBar.add(bImportar);

        bRefrescar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/gear_replace.png")));
        bRefrescar.setToolTipText(rb.getString("BCON_SERVIDOR"));
        bRefrescar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bRefrescarActionPerformed(evt);
            }
        });

        toolBar.add(bRefrescar);

        bCancelarOperaciones.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/delete2.png")));
        bCancelarOperaciones.setEnabled(false);
        bCancelarOperaciones.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelarOperacionesActionPerformed(evt);
            }
        });

        toolBar.add(bCancelarOperaciones);

        toolBar.addSeparator();
        bCascade.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/elements_selection.png")));
        bCascade.setToolTipText(rb.getString("B_CASCADE"));
        bCascade.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCascadeActionPerformed(evt);
            }
        });

        toolBar.add(bCascade);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/minimizar.gif")));
        jButton1.setToolTipText(rb.getString("ICONIZAR"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        toolBar.add(jButton1);

        toolBar.addSeparator();
        bSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/exit.png")));
        bSalir.setToolTipText(rb.getString("MNU_SALIR"));
        bSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirActionPerformed(evt);
            }
        });

        toolBar.add(bSalir);

        getContentPane().add(toolBar, java.awt.BorderLayout.NORTH);

        mnuFichero.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/package.png")));
        mnuFichero.setText(rb.getString("MNU_FICHERO"));
        mnuPreferncias.setText(rb.getString("MNU_PREFS"));
        mnuPreferncias.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuPrefernciasActionPerformed(evt);
            }
        });

        mnuFichero.add(mnuPreferncias);

        mnuVersion.setText(rb.getString("MNU_VERSION"));
        mnuVersion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuVersionActionPerformed(evt);
            }
        });

        mnuFichero.add(mnuVersion);

        mnuFichero.add(jSeparator2);

        mnuSalir.setText(rb.getString("MNU_SALIR"));
        mnuSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuSalirActionPerformed(evt);
            }
        });

        mnuFichero.add(mnuSalir);

        jMenuBar.add(mnuFichero);

        mnuOperaciones.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/cube_molecule.png")));
        mnuOperaciones.setText(rb.getString("MNU_OPERACIONES"));
        mnuImportar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/document_up.png")));
        mnuImportar.setText(rb.getString("MNU_IMP_FICHERO"));
        mnuImportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuImportarActionPerformed(evt);
            }
        });

        mnuOperaciones.add(mnuImportar);

        mnuBackUp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/cookies24.png")));
        mnuBackUp.setText(rb.getString("MNU_BACKUP"));
        mnuCopia.setText(rb.getString("MNU_BACKUP_COPIA"));
        mnuCopia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuCopiaActionPerformed(evt);
            }
        });

        mnuBackUp.add(mnuCopia);

        mnuRestaura.setText(rb.getString("MNU_BACKUP_RESTAURA"));
        mnuRestaura.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuRestauraActionPerformed(evt);
            }
        });

        mnuBackUp.add(mnuRestaura);

        mnuBackUp.add(jSeparator3);

        mnuEstructuraAServer.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/server_id_card.png")));
        mnuEstructuraAServer.setText(rb.getString("MNU_ESTRUCTURA_EN_SERVER"));
        mnuEstructuraAServer.setEnabled(false);
        mnuEstructuraAServer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuEstructuraAServerActionPerformed(evt);
            }
        });

        mnuBackUp.add(mnuEstructuraAServer);

        mnuOperaciones.add(mnuBackUp);

        jMenuBar.add(mnuOperaciones);

        mnuVentanas.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/windows.png")));
        mnuVentanas.setText(rb.getString("MNU_VENTANAS"));
        mnucbMensages.setText(rb.getString("TIT_MSG"));
        mnucbMensages.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/policeman_usa.png")));
        mnucbMensages.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                mnucbMensagesItemStateChanged(evt);
            }
        });

        mnuVentanas.add(mnucbMensages);

        mnuVentanas.add(jSeparator1);

        mnucbNU.setText(rb.getString("MNU_NUEVOS_USU"));
        mnucbNU.setEnabled(false);
        mnucbNU.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_into.png")));
        mnucbNU.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                mnucbNUStateChanged(evt);
            }
        });

        mnuVentanas.add(mnucbNU);

        mnucbUaB.setText(rb.getString("MNU_USU_A_BORRAR"));
        mnucbUaB.setEnabled(false);
        mnucbUaB.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_delete.png")));
        mnucbUaB.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                mnucbUaBItemStateChanged(evt);
            }
        });

        mnuVentanas.add(mnucbUaB);

        mnucbUQNC.setText(rb.getString("MNU_USUARIS_QUE_NO_CAMBIAN"));
        mnucbUQNC.setEnabled(false);
        mnucbUQNC.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/user1_information.png")));
        mnucbUQNC.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                mnucbUQNCItemStateChanged(evt);
            }
        });

        mnuVentanas.add(mnucbUQNC);

        jMenuBar.add(mnuVentanas);

        setJMenuBar(jMenuBar);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-911)/2, (screenSize.height-643)/2, 911, 643);
    }// </editor-fold>//GEN-END:initComponents
    
    private void pBorrarNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pBorrarNActionPerformed
        nodoBorrar();
    }//GEN-LAST:event_pBorrarNActionPerformed
    
    private void pEditarNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pEditarNActionPerformed
        nodoEditar();
    }//GEN-LAST:event_pEditarNActionPerformed
    
    private void pBorrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pBorrarActionPerformed
        nodoBorrar();
    }//GEN-LAST:event_pBorrarActionPerformed
    
    private void bDefectosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDefectosActionPerformed
        txtUserAdmin.setText("Administrator");
        txtDC.setText("intracentre");
        listaAlgoritmos.setSelectedIndex(1);
        chConservarHome.setSelected(true);
        dirGuargar.setText("/root");
        chDebug.setSelected(false);
        txtShell.setText("/bin/bash");
        txtHome.setText("/home");
        chBorraGrpUsu.setSelected(false);
        chGrupUsers.setSelected(true);
    }//GEN-LAST:event_bDefectosActionPerformed
    
    private void bCancelarPrefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelarPrefActionPerformed
        cargaPrefs();
        dlgPreferencias.setVisible(false);
    }//GEN-LAST:event_bCancelarPrefActionPerformed
    
    private void bGrabarPrefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bGrabarPrefActionPerformed
        grabaPrefs();
        dlgPreferencias.setVisible(false);
    }//GEN-LAST:event_bGrabarPrefActionPerformed
    
    private void txtBusquedaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtBusquedaActionPerformed
        bBuscarActionPerformed(evt);
    }//GEN-LAST:event_txtBusquedaActionPerformed
    
    private void bBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bBuscarActionPerformed
        
        TreePath tp=BuscaStringEnArbol(arbol, txtBusqueda.getText());
        if (tp!=null) {
            arbol.setSelectionPath(tp);
            arbol.setExpandsSelectedPaths(true);
            arbol.scrollPathToVisible(tp);
            arbol.repaint();
        }
    }//GEN-LAST:event_bBuscarActionPerformed
    
    private void bgrupselActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bgrupselActionPerformed
        
        
        gdefecto=(GrupoLDAP)listGruposAlta.getSelectedValue();
        
        if (gdefecto==null) {
            JOptionPane.showConfirmDialog(this,rb.getString("MUST_SELECT_GROUP"),ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        dlgGrupo.setVisible(false);
        
    }//GEN-LAST:event_bgrupselActionPerformed
    
    private void bgrupdefectoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bgrupdefectoActionPerformed
        gdefecto=null;
        dlgGrupo.setVisible(false);
        
    }//GEN-LAST:event_bgrupdefectoActionPerformed
    
    private void bMUsuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMUsuActionPerformed
        UsuarioLDAP u=new UsuarioLDAP();
        //TODO revisar entradas
        String s1=new String(txtPwd1.getPassword());
        String s2=new String(txtPwd2.getPassword());
        
        if (!s1.equals(s2)) {
            JOptionPane.showMessageDialog(yo,PWD_NO_COINCIDEN,ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        u.setCn(txtNOM.getText()+" "+txtCNOM.getText());
        u.setSn(txtCNOM.getText());
        u.setGivenName(txtNOM.getText());
        u.setSagaID(txtSagaID.getText());
        if (u.getSagaID().equals("")) {
            JOptionPane.showMessageDialog(yo,rb.getString("MUST_INDICATE_SAGAID"),ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        u.setUid(txtUID.getText());
        u.setPlainPassword(s1);
        
        u.setHomeDirectory(txtHomeUsu.getText());
        u.setLoginShell(txtShellUsu.getText());
        
        Object grprin=cbGrupPrincipal.getSelectedItem();
        if (grprin instanceof GrupoLDAP) {
            GrupoLDAP gldap=(GrupoLDAP) grprin;
            u.setGidNumber(gldap.getGidNumber());
        } else {
            unixUtil.unixGroup grpu=(unixUtil.unixGroup) grprin;
            u.setGidNumber(grpu.getGidNumber());
            grpu.ponUser(u.getUid());
        }
        if (chGrupUsers.isSelected()) {
            if (versionLINKAT==1) {
                unix_grp_group.ponUser(u.getUid());
            } //else {
            //u.masGrupos(grp_users);
            //}
        }
        if (versionLINKAT==1) escribeEtcGroups();
        u.modificarManual(ss.getCtx(),this);
        u.modificarEnServerLDAP(ss.getCtx(),this);
        usuarios.remove(u);
        usuarios.add(u);
        
        
        for (int j=0;j<nodoUsuarios.getChildCount();j++) {
            DefaultMutableTreeNode dmtn=(DefaultMutableTreeNode) nodoUsuarios.getChildAt(j);
            if (dmtn.getUserObject().equals(u)) {
                dmtn.setUserObject(u);
                break;
            }
        }
        
        for (int i=0;i<dlm_gu.size();i++) {
            if (dlm_gu.elementAt(i) instanceof GrupoLDAP) {
                GrupoLDAP g=(GrupoLDAP) dlm_gu.elementAt(i);
                DefaultMutableTreeNode minodo=null;
                for (int j=0;j<nodoGrupos.getChildCount();j++) {
                    DefaultMutableTreeNode dmtn=(DefaultMutableTreeNode) nodoGrupos.getChildAt(j);
                    if (dmtn.getUserObject().equals(g)) minodo=dmtn;
                }
                if (g.isSelected()  ) {
                    if (!g.getMiembros().contains(u)) {
                        u.masGrupos(g);
                        g.masMiembros(u.getUid(),u);
                        try {
                            g.addMemberLDAP(ss.getCtx(),u,txtDC.getText());
                            if (minodo!=null) minodo.add(new DefaultMutableTreeNode(u));
                        } catch (NamingException ne) {
                            mensage("Not add member in group "+g);
                            mensage(ne);
                        }
                    }
                } else {
                    u.menosGrupos(g);
                    g.menosMiembros(u.getUid());
                    g.minusMemberLDAP(ss.getCtx(),u,txtDC.getText());
                    DefaultMutableTreeNode minodo2=null;
                    for (int j=0;j<minodo.getChildCount();j++) {
                        DefaultMutableTreeNode dmtn=(DefaultMutableTreeNode) minodo.getChildAt(j);
                        if (dmtn.getUserObject().equals(u)) minodo2=dmtn;
                    }
                    if (minodo!=null && minodo2!=null) minodo.remove(minodo2);
                }
            }
        }
        dtm.reload();
        arbol.repaint();
        for (int i=0;i<dlm_gu.size();i++) {
            if (dlm_gu.elementAt(i) instanceof GrupoLDAP) {
                GrupoLDAP g=(GrupoLDAP) dlm_gu.elementAt(i);
                Enumeration enumeracion=g.getMiembros().elements();
                while (enumeracion.hasMoreElements()) {
                    UsuarioLDAP ux=(UsuarioLDAP) enumeracion.nextElement();
                    if (ux.equals(u)) {g.setSelected(true);break;} else {g.setSelected(false);}
                }
            }
        }
        if (ifEditGroup.isVisible()) llenaifEditGroup();
        lgrupsUsu.repaint();
    }//GEN-LAST:event_bMUsuActionPerformed
    
    
    private void nodoBorrar()  {
        if (nodoMenu.getUserObject()==null) return;
        if (nodoMenu.getUserObject() instanceof UsuarioLDAP) {
            final DefaultMutableTreeNode dt1=(DefaultMutableTreeNode) nodoMenu.getParent();
            if (dt1.getUserObject() instanceof GrupoLDAP) {
                Object[] options = {SI_ADELANTE,NI_HABLAR};
                int n = JOptionPane.showOptionDialog(yo,BAJA_USUARIO_EN_GRUPO,PREGUNTA,JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
                if (n==1) return;
                Thread ts=new Thread() {
                    public void run() {
                        GrupoLDAP g=(GrupoLDAP)dt1.getUserObject();
                        UsuarioLDAP u=(UsuarioLDAP) nodoMenu.getUserObject();
                        try {
                            if (chGrupUsers.isSelected()) {
                                if (versionLINKAT==1) {
                                    unix_grp_group.quitaUser(u);
                                    escribeEtcGroups();
                                }
                            }
                            u.menosGrupos(g);
                            g.menosMiembros(u.getUid());
                            g.minusMemberLDAP(ss.getCtx(),u,txtDC.getText());
                            nodoMenu.removeFromParent();
                            dtm.reload();
                            arbol.repaint();
                            if (ifEditUser.isVisible()) llenaifEditUser();
                            if (ifEditGroup.isVisible()) llenaifEditGroup();
                        } catch (Exception eee) {}
                    }
                };
                ts.start();
            } else {
                Object[] options = {SI_ADELANTE,NI_HABLAR};
                int n = JOptionPane.showOptionDialog(yo,BAJA_USUARIO,PREGUNTA,JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
                if (n==1) return;
                UsuarioLDAP u=(UsuarioLDAP) nodoMenu.getUserObject();
                ObjectThread ts;
                try {
                    ts = new ObjectThread(u) {
                        public void run() {
                            UsuarioLDAP u = (UsuarioLDAP) nodoMenu.getUserObject();
                            if (u.borrar(ss.getCtx(), yo)) {
                                dlm_usu.removeElement(u);
                                u.setBorrado(true);
                                arbol.repaint();
                            }
                            acaba();
                        }
                        
                    };
                    ts.start();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        } else if (nodoMenu.getUserObject() instanceof GrupoLDAP) {
            Object[] options = {SI_ADELANTE,NI_HABLAR};
            int n = JOptionPane.showOptionDialog(yo,BAJA_GRUPO,PREGUNTA,JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
            if (n==1) return;
            Thread ts=new Thread() {
                public void run() {
                    GrupoLDAP g=(GrupoLDAP)nodoMenu.getUserObject();
                    if (g.borrarEnServerLDAP(ss.getCtx(),yo)) {
                        g.setBorrado(true);
                        dlm_gu.removeElement(g);
                        grupos.remove(g);
                        arbol.repaint();
                    }
                }
            };
            ts.start();
        }
    }
    
    
    private void ifEditGroupInternalFrameIconified(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_ifEditGroupInternalFrameIconified
        iconiza(evt);
    }//GEN-LAST:event_ifEditGroupInternalFrameIconified
    
    private void ifEditUserInternalFrameIconified(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_ifEditUserInternalFrameIconified
        iconiza(evt);
    }//GEN-LAST:event_ifEditUserInternalFrameIconified
    
    private void bSEG1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSEG1ActionPerformed
        ifEditUser.setVisible(false);
    }//GEN-LAST:event_bSEG1ActionPerformed
    
    private void bAUsuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bAUsuActionPerformed
        //TODO revisar entradas
        String s1=new String(txtPwd1.getPassword());
        String s2=new String(txtPwd2.getPassword());
        
        if (s1.trim().equals("")) {
            JOptionPane.showMessageDialog(yo,PWD_VACIO,ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        if (!s1.equals(s2)) {
            JOptionPane.showMessageDialog(yo,PWD_NO_COINCIDEN,ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        UsuarioLDAP u=new UsuarioLDAP();
        
        u.setCn(txtNOM.getText()+" "+txtCNOM.getText());
        u.setSn(txtCNOM.getText());
        u.setGivenName(txtNOM.getText());
        u.setSagaID(txtSagaID.getText());
        
        u.setUid(txtUID.getText());
        u.setPlainPassword(new String(txtPwd1.getPassword()));
        u.setHomeDirectory(txtHomeUsu.getText());
        u.setLoginShell(txtShellUsu.getText());
        if (u.getSagaID().equals("")) {
            JOptionPane.showMessageDialog(yo,rb.getString("MUST_INDICATE_SAGAID"),ATT,JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        if (u.crearManual(ss.getCtx(),this)) {
            try {
                ponGruposUsuario(u);
                DefaultMutableTreeNode dmt=new DefaultMutableTreeNode(u);
                nodoUsuarios.add(dmt);
                dlm_usu.addElement(u);
                usuarios.add(u);
                arbol.treeDidChange();
                arbol.updateUI();
                arbol.repaint();
            } catch (NamingException ex) {
                ex.printStackTrace();
            }
            
        }
    }//GEN-LAST:event_bAUsuActionPerformed
    
    private void ponGruposUsuario(UsuarioLDAP u) throws NamingException {
        if (chGrupUsers.isSelected()) {
            if (versionLINKAT==1) {
                unix_grp_group.ponUser(u.getUid());
            } else {
                u.masGrupos(grp_users);
            }
        }
        for (int i=0;i<dlm_gu.size();i++) {
            GrupoLDAP g=(GrupoLDAP) dlm_gu.elementAt(i);
            if (g.isSelected()) {
                u.masGrupos(g);
                g.addMemberLDAP(ss.getCtx(),u,txtDC.getText());
                g.masMiembros(u.getUid(),u);
            }
        }
        
        if (versionLINKAT==1) escribeEtcGroups();
        
    }
    
    
    
    private void bSEGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSEGActionPerformed
        ifEditGroup.setVisible(false);
    }//GEN-LAST:event_bSEGActionPerformed
    
    private void bAGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bAGActionPerformed
        GrupoLDAP g=new GrupoLDAP();
        g.setCn(txtNomGrup.getText());
        g.setSelected(false);
        g.setNamedobject(true);
        g.setGroupofnames(false);
        if (g.newLDAP(ss.getCtx(),this)) {
            grupos.add(g);
            mensage(""+g);
            DefaultMutableTreeNode dmt=new DefaultMutableTreeNode(g);
            nodoGrupos.add(dmt);
            dlm_gu.addElement(g);
            lgrupsUsu.updateUI();
            arbol.treeDidChange();
            arbol.updateUI();
            arbol.repaint();
        }
    }//GEN-LAST:event_bAGActionPerformed
    
    private void pEditarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pEditarActionPerformed
        nodoEditar();
    }//GEN-LAST:event_pEditarActionPerformed
    
    
    private void llenaifEditGroup()  {
        GrupoLDAP g;
        if (nodoMenu.getUserObject() instanceof GrupoLDAP) {
            g=(GrupoLDAP) nodoMenu.getUserObject();
            g_grupo_actual=g;
        }
        if (g_grupo_actual==null) return;
        g=g_grupo_actual;
        txtNomGrup.setText(g.getCn());
        for (int i=0;i<dlm_usu.size();i++) {
            UsuarioLDAP usu=(UsuarioLDAP) dlm_usu.elementAt(i);
            if (g.getMiembros().containsValue(usu))
                usu.setSelected(true);
            else
                usu.setSelected(false);
        }
        ifEditGroup.repaint();
    }
    
    private void llenaifEditUser()  {
        UsuarioLDAP u;
        if (nodoMenu.getUserObject() instanceof UsuarioLDAP) {
            u=(UsuarioLDAP) nodoMenu.getUserObject();
            g_usu_actual=u;
        }
        if (g_usu_actual==null) return;
        u=g_usu_actual;
        txtNomUsu.setText(u.getCn());
        txtUID.setText(u.getUid());
        txtPwd1.setText("");
        txtPwd2.setText("");
        txtHomeUsu.setText(u.getHomeDirectory());
        txtShellUsu.setText(u.getLoginShell());
        txtCNOM.setText(u.getSn());
        txtNOM.setText(u.getGivenName());
        txtSagaID.setText(u.getSagaID());
        
        
        for (int i=0;i<dlm_gu.size();i++) {
            if (dlm_gu.elementAt(i) instanceof GrupoLDAP) {
                GrupoLDAP g=(GrupoLDAP) dlm_gu.elementAt(i);
                Enumeration enumeracion=g.getMiembros().elements();
                while (enumeracion.hasMoreElements()) {
                    UsuarioLDAP ux=(UsuarioLDAP) enumeracion.nextElement();
                    if (ux.equals(u)) {g.setSelected(true);break;} else {g.setSelected(false);}
                }
            }
            if (dlm_gu.elementAt(i) instanceof unixUtil.unixGroup) {
                unixUtil.unixGroup g=(unixUtil.unixGroup) dlm_gu.elementAt(i);
                Enumeration enumeracion=g.getUsuarios().elements();
                while (enumeracion.hasMoreElements()) {
                    String ux=(String) enumeracion.nextElement();
                    if (u.getUid().equals(ux)) {g.setSelected(true);break;} else {g.setSelected(false);}
                }
            }
            
        }
        
        lgrupsUsu.repaint();
        
        for (int i=0;i<cbGrupos.getSize();i++) {
            Object ogrp=cbGrupos.getElementAt(i);
            
            if (ogrp instanceof GrupoLDAP) {
                GrupoLDAP g=(GrupoLDAP) ogrp;
                if (u.getGidNumber().equals(g.getGidNumber())) {
                    cbGrupPrincipal.setSelectedIndex(i);
                    break;
                }
            } else {
                unixUtil.unixGroup g=(unixUtil.unixGroup) ogrp;
                if (u.getGidNumber().equals(g.getGidNumber())) {
                    cbGrupPrincipal.setSelectedIndex(i);
                    break;
                } else {
                    g.quitaUser(u);
                }
                
            }
            
            
            
        }
        
        
        ifEditUser.pack();
    }
    
    
    private void nodoEditar()  {
        if (nodoMenu.getUserObject() instanceof UsuarioLDAP) {
            llenaifEditUser();
            if (!ifEditUser.isVisible()) {
                ifEditUser.setVisible(true);
                ifEditUser.toFront();
                try { ifEditUser.setSelected(true);} catch (PropertyVetoException ex) {ex.printStackTrace();}
            }
        } else if (nodoMenu.getUserObject() instanceof GrupoLDAP) {
            llenaifEditGroup();
            if (!ifEditGroup.isVisible()) {
                ifEditGroup.setVisible(true);
                ifEditGroup.toFront();
                try {ifEditGroup.setSelected(true);} catch (PropertyVetoException ex) {ex.printStackTrace();}
            }
        }
    }
    
    
    private void arbolMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_arbolMouseClicked
        if (evt.getClickCount()>1) {
            TreePath hojaSel=arbol.getPathForLocation(evt.getX(),evt.getY());
            nodoMenu=(DefaultMutableTreeNode) hojaSel.getLastPathComponent();
            nodoEditar();
        }
    }//GEN-LAST:event_arbolMouseClicked
    
    private void arbolMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_arbolMouseReleased
        if (evt.isPopupTrigger()) {
            pmUsu.show((Component)evt.getSource(),evt.getX(),evt.getY());
            TreePath hojaSel=arbol.getPathForLocation(evt.getX(),evt.getY());
            try {
                nodoMenu=(DefaultMutableTreeNode) hojaSel.getLastPathComponent();
            } catch (Exception e) {nodoMenu=null;}
        }
    }//GEN-LAST:event_arbolMouseReleased
    
    private void arbolMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_arbolMousePressed
        if (evt.isPopupTrigger()) {
            pmUsu.show((Component)evt.getSource(),evt.getX(),evt.getY());
            TreePath hojaSel=arbol.getPathForLocation(evt.getX(),evt.getY());
            try {
                nodoMenu=(DefaultMutableTreeNode) hojaSel.getLastPathComponent();
            } catch (Exception e) {nodoMenu=null;}
        }
    }//GEN-LAST:event_arbolMousePressed
    
    private void chConservarHomeItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chConservarHomeItemStateChanged
        dirGuargar.setEnabled(chConservarHome.isSelected());
        bDirDef.setEnabled(chConservarHome.isSelected());
    }//GEN-LAST:event_chConservarHomeItemStateChanged
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        JInternalFrame[] frames = escritorio.getAllFrames();
        
        for (int i = 0; i < frames.length; i++){
            if (!frames[i].isIcon()) {
                try {
                    frames[i] .setIcon(true);
                }catch(PropertyVetoException e) {}
            }
        }
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void bBorrarMsgActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bBorrarMsgActionPerformed
        msgTxtArea.setText("");
    }//GEN-LAST:event_bBorrarMsgActionPerformed
    
    private void mnuEstructuraAServerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuEstructuraAServerActionPerformed
        Object[] options = {SI_ADELANTE,NI_HABLAR};
        int n = JOptionPane.showOptionDialog(yo,ESTA_A_PUNTO_DE_APLICAR_EN_SERVER,PREGUNTA,JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
        if (n==1) return;
        Thread ts=new Thread() {
            public void run() {
                ponerEstructuraEnServer();
                Object[] options = {"OK"};
                int n = JOptionPane.showOptionDialog(yo,rb.getString("BASE_DESSERIALIZADA"),ATT,JOptionPane.YES_OPTION,
                        JOptionPane.INFORMATION_MESSAGE,null,options,options[0]);
                refrescarArbol();
            }
        };
        ts.start();
    }//GEN-LAST:event_mnuEstructuraAServerActionPerformed
    
    private void bsalirAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bsalirAboutActionPerformed
        dlgAbout.setVisible(false);
    }//GEN-LAST:event_bsalirAboutActionPerformed
    
    private void mnuVersionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuVersionActionPerformed
        dlgAbout.setVisible(true);
    }//GEN-LAST:event_mnuVersionActionPerformed
    
    private void bDesmarcarUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDesmarcarUIActionPerformed
        Enumeration enumeracion=dlm_igual.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(false);
        }
        listaUsuariosIgual.repaint();
    }//GEN-LAST:event_bDesmarcarUIActionPerformed
    
    private void bMarcarUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMarcarUIActionPerformed
        Enumeration enumeracion=dlm_igual.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(true);
        }
        listaUsuariosIgual.repaint();
    }//GEN-LAST:event_bMarcarUIActionPerformed
    
    private void bPasasBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bPasasBActionPerformed
        
        for (int i=dlm_igual.getSize()-1;i>=0;i--) {
            UsuarioLDAP usu=(UsuarioLDAP) dlm_igual.get(i);
            if (usu.isSelected()) {
                dlm_igual.removeElement(usu);
                dlm_borrar.addElement(usu);
            }
        }
        
    }//GEN-LAST:event_bPasasBActionPerformed
    
    private void chDebugItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chDebugItemStateChanged
        if (chDebug.isSelected()) debug=true; else debug=false;
    }//GEN-LAST:event_chDebugItemStateChanged
    
    private void bGuardarLogActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bGuardarLogActionPerformed
        JFileChooser fc=new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        
        fc.setFileFilter(new FiltroLOG());
        fc.setFileView(new KemitLogFileView());
        
        fc.setApproveButtonText(rb.getString("SAVE"));
        
        
        fc.setDialogTitle(REGISTRE_OPERACION);
        
        int ret=fc.showSaveDialog(this);
        
        
        if (ret==JFileChooser.APPROVE_OPTION) {
            File f=fc.getSelectedFile();
            if (getExtension(f).equals("") ) {
                f=new File(f.getAbsolutePath()+".log");
            }
            try {
                BufferedWriter out = new BufferedWriter(new FileWriter(f));
                StringTokenizer st=new StringTokenizer(msgTxtArea.getText(),"\n");
                while (st.hasMoreTokens()) {
                    out.write(st.nextToken()+"\n");
                }
                out.close();
            } catch (IOException e) { if (debug) mensage(e); }
        }
        
    }//GEN-LAST:event_bGuardarLogActionPerformed
    
    private void mnuPrefernciasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuPrefernciasActionPerformed
        dlgPreferencias.setVisible(true);
    }//GEN-LAST:event_mnuPrefernciasActionPerformed
    
    public int getAlgoritmo() {
        return listaAlgoritmos.getSelectedIndex();
    }
    
    private void bDirDefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDirDefActionPerformed
        
        JFileChooser fc=new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        
        int ret=fc.showDialog(this,ESCOLLIR);
        fc.setApproveButtonText(ESCOLLIR);
        
        if (ret==JFileChooser.APPROVE_OPTION) {
            File f=fc.getSelectedFile();
            dirGuargar.setText(f.getAbsolutePath());
        }
    }//GEN-LAST:event_bDirDefActionPerformed
    
    private void bSalirPrefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirPrefActionPerformed
        dlgPreferencias.setVisible(false);
    }//GEN-LAST:event_bSalirPrefActionPerformed
    
    private void bRefrescarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bRefrescarActionPerformed
        refrescarArbol();
    }//GEN-LAST:event_bRefrescarActionPerformed
    
    private void bBorrarUActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bBorrarUActionPerformed
        
        Object[] options = {SI_ADELANTE,NI_HABLAR};
        int n = JOptionPane.showInternalOptionDialog(ifUsuariosBorrar,ESTA_A_PUNTO_DE_BORRAR,PREGUNTA,JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
        
        if (n==1) return;
        int seleccionados=0;
        for (int i=dlm_borrar.getSize()-1;i>=0;i--) {
            UsuarioLDAP usu=(UsuarioLDAP) dlm_borrar.get(i);
            if (usu.isSelected()) seleccionados++;
        }
        barra.setValue(0);
        barra.setMaximum(seleccionados*4);
        
        Thread ts=new Thread() {
            public void run() {
                try {
                    for (int i=dlm_borrar.getSize()-1;i>=0;i--) {
                        UsuarioLDAP usu=(UsuarioLDAP) dlm_borrar.get(i);
                        if (usu.isSelected()) {
                            usu.borrar(ss.getCtx(),yo);
                            dlm_usu.removeElement(usu);
                            usu.setBorrado(true);
                            dlm_borrar.remove(i);
                            arbol.repaint();
                            listaUsuariosBorrar.repaint();
                        }
                    }
                    dlgAvances.setVisible(false);
                    refrescarArbol();
                    JOptionPane.showInternalMessageDialog(ifUsuariosBorrar,OPEXIT,ATT,JOptionPane.INFORMATION_MESSAGE);
                } catch (Exception e) {
                    if (debug) mensage(e);
                    dlgAvances.setVisible(false);
                    JOptionPane.showInternalMessageDialog(ifUsuariosBorrar,OPMAL,ATT,JOptionPane.ERROR_MESSAGE);
                }
            }
        };
        try {ts.start();} catch (Exception e) {if (debug) mensage(e);}
        dlgAvances.setVisible(true);
        
    }//GEN-LAST:event_bBorrarUActionPerformed
    
    private void binsertarNUActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_binsertarNUActionPerformed
        Object[] options = {SI_ADELANTE,NI_HABLAR};
        int n = JOptionPane.showInternalOptionDialog(ifUsuariosNuevos,ESTA_A_PUNTO_DE_INSERTAR,PREGUNTA,JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,null,options,options[0]);
        if (n==1) return;
        int seleccionados=0;
        for (int i=dlm_new.getSize()-1;i>=0;i--) {
            UsuarioLDAP usu=(UsuarioLDAP) dlm_new.get(i);
            if (usu.isSelected()) seleccionados++;
        }
        barra.setValue(0);
        barra.setMaximum(seleccionados*10);
        
        gdefecto=null;
        if (!FileParser.isColgrupo() ) {
            dlgGrupo.setVisible(true);
            dlgGrupo.toFront();
        }
        Thread ts=new Thread() {
            public void run() {
                try {
                    usuCreados=new Vector();
                    for (int i=dlm_new.getSize()-1;i>=0;i--) {
                        UsuarioLDAP usu=(UsuarioLDAP) dlm_new.get(i);
                        if (usu.isSelected()) {
                            if (gdefecto!=null) {
                                usu.setGidNumber(gdefecto.getGidNumber());
                            }
                            if (chGrupUsers.isSelected()) {
                                if (versionLINKAT==1) {
                                    unix_grp_group.ponUser(usu.getUid());
                                } else {
                                    usu.masGrupos(grp_users);
                                }
                            }
                            if (usu.crear(ss.getCtx(),yo)) {
                                dlm_usu.addElement(usu);
                                usuCreados.add(usu);
                                dtm.insertNodeInto(new DefaultMutableTreeNode(usu),nodoUsuarios,nodoUsuarios.getChildCount());
                                dlm_new.remove(i);
                                dlm_igual.addElement(usu);
                                arbol.repaint();
                                listaNuevosUsuarios.repaint();
                            } else { throw new Exception("Error usuari:"+usu.getDisplayName());}
                        }
                    }
                    if (versionLINKAT==1) escribeEtcGroups();
                    dlgAvances.setVisible(false);
                    Thread ts2=new Thread() {
                        public void run() {
                            JFileChooser fc=new JFileChooser();
                            fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
                            fc.setFileFilter(new FiltroPDF());
                            fc.setFileView(new KemitFilePDFView());
                            fc.setApproveButtonText(rb.getString("SAVE"));
                            fc.setDialogTitle(REGISTRE_OPERACION);
                            int ret=fc.showSaveDialog(yo);
                            
                            if (ret==JFileChooser.APPROVE_OPTION) {
                                File f=fc.getSelectedFile();
                                if (getExtension(f).equals("") ) {
                                    f=new File(f.getAbsolutePath()+".pdf");
                                }
                                String file=f.getAbsolutePath();
                                try {
                                    Imprimir imp=new Imprimir();
                                    imp.informeSync(usuCreados,file);
                                    imp.ShowPDF(file);
                                } catch (Exception e) {
                                    if (debug) mensage(e);
                                }
                            }
                            refrescarArbol();
                            JOptionPane.showInternalMessageDialog(ifUsuariosNuevos,OPEXIT,ATT,JOptionPane.INFORMATION_MESSAGE);
                        }
                    };
                    ts2.start();
                } catch (Exception e) {
                    if (debug) mensage(e);
                    dlgAvances.setVisible(false);
                    JOptionPane.showInternalMessageDialog(ifUsuariosNuevos,OPMAL,ATT,JOptionPane.ERROR_MESSAGE);
                }
            }
        };
        try {ts.start();} catch (Exception e) {if (debug) mensage(e);}
        dlgAvances.setVisible(true);
        
    }//GEN-LAST:event_binsertarNUActionPerformed
    
    private void bCascadeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCascadeActionPerformed
        
        JInternalFrame[] frames = escritorio.getAllFrames();
        int frameDistance=30;
        int x = 0;
        int y = 0;
        int width = escritorio.getWidth() / 2;
        int height = escritorio.getHeight() / 2;
        
        for (int i = 0; i < frames.length; i++){
            if (!frames[i].isIcon()) {
                try {
                    frames[i].setMaximum(false);
                    frames[i].setLocation(x, y);
                    frames[i].toFront();
                    //frames[i].reshape(x, y, width, height);
                    
                    x += frameDistance;
                    y += frameDistance;
                    if (x + width > escritorio.getWidth()) x = 0;
                    if (y + height > escritorio.getHeight()) y = 0;
                }catch(PropertyVetoException e) {}
            }
        }
        
    }//GEN-LAST:event_bCascadeActionPerformed
    
    private void ifUsuariosIgualInternalFrameIconified(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_ifUsuariosIgualInternalFrameIconified
        iconiza(evt);
    }//GEN-LAST:event_ifUsuariosIgualInternalFrameIconified
    
    private void ifUsuariosBorrarInternalFrameIconified(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_ifUsuariosBorrarInternalFrameIconified
        iconiza(evt);
    }//GEN-LAST:event_ifUsuariosBorrarInternalFrameIconified
    
    private void bDesmarcarUBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDesmarcarUBActionPerformed
        Enumeration enumeracion=dlm_borrar.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(false);
        }
        listaUsuariosBorrar.repaint();
    }//GEN-LAST:event_bDesmarcarUBActionPerformed
    
    private void bMarcarUBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMarcarUBActionPerformed
        Enumeration enumeracion=dlm_borrar.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(true);
        }
        listaUsuariosBorrar.repaint();
    }//GEN-LAST:event_bMarcarUBActionPerformed
    
    private void bDesmarcarUNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDesmarcarUNActionPerformed
        Enumeration enumeracion=dlm_new.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(false);
        }
        listaNuevosUsuarios.repaint();
    }//GEN-LAST:event_bDesmarcarUNActionPerformed
    
    private void bMarcarUNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMarcarUNActionPerformed
        Enumeration enumeracion=dlm_new.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(true);
        }
        listaNuevosUsuarios.repaint();
    }//GEN-LAST:event_bMarcarUNActionPerformed
    
    private void mnucbUQNCItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_mnucbUQNCItemStateChanged
        
        if (mnucbUQNC.isSelected()) ifUsuariosIgual.setVisible(true);else ifUsuariosIgual.setVisible(false);
    }//GEN-LAST:event_mnucbUQNCItemStateChanged
    
    private void mnucbUaBItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_mnucbUaBItemStateChanged
        
        if (mnucbUaB.isSelected()) ifUsuariosBorrar.setVisible(true);else ifUsuariosBorrar.setVisible(false);
    }//GEN-LAST:event_mnucbUaBItemStateChanged
    
    public void refrescarArbol() {
        raiz=new DefaultMutableTreeNode(RAIZ);
        nodoUsuarios=new DefaultMutableTreeNode(USUARIOS);
        nodoGrupos=new DefaultMutableTreeNode(GRUPOS);
        cbGrupos=new DefaultComboBoxModel();
        
        dtm=new DefaultTreeModel(raiz);
        raiz.add(nodoUsuarios);
        raiz.add(nodoGrupos);
        
        arbol.setModel(dtm);
        dlm_usu=new DefaultListModel();
        try {
            llenaUsuariosDesdeLDAP();
            llenaGruposDesdeLDAP();
            ifEditUser.setVisible(false);
            ifEditGroup.setVisible(false);
        } catch (NamingException e) {if (debug) mensage(e);}
    }
    
    private void bCancelarOperacionesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelarOperacionesActionPerformed
        
        Object[] options = {SI_ADELANTE,NI_HABLAR};
        int n = JOptionPane.showOptionDialog(yo,ESTA_A_PUNTO_DE_CANCELAR,PREGUNTA,JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,null,options,options[1]);
        
        if (n==1) return;
        
        
        refrescarArbol();
        
        mnucbUQNC.setSelected(false);
        mnucbUaB.setSelected(false);
        mnucbNU.setSelected(false);
        
        mnucbUQNC.setEnabled(false);
        mnucbUaB.setEnabled(false);
        mnucbNU.setEnabled(false);
        
        dlm_borrar=new DefaultListModel();
        listaUsuariosBorrar.setModel(dlm_borrar);
        dlm_igual=new DefaultListModel();
        listaUsuariosIgual.setModel(dlm_igual);
        dlm_new=new DefaultListModel();
        listaNuevosUsuarios.setModel(dlm_new);
        
        usuariosNEW=new Vector();
        gruposNEW=new Vector();
        mnuEstructuraAServer.setEnabled(false);
        bCancelarOperaciones.setEnabled(false);
        
    }//GEN-LAST:event_bCancelarOperacionesActionPerformed
    
    private void bSalirUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirUIActionPerformed
        mnucbUQNC.setSelected(false);
    }//GEN-LAST:event_bSalirUIActionPerformed
    
    private void bSalirUBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirUBActionPerformed
        mnucbUaB.setSelected(false);
    }//GEN-LAST:event_bSalirUBActionPerformed
    
    private void mnucbMensagesItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_mnucbMensagesItemStateChanged
        if (mnucbMensages.isSelected()) ifMensages.setVisible(true);else ifMensages.setVisible(false);
    }//GEN-LAST:event_mnucbMensagesItemStateChanged
    
    private void bSalirNUActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirNUActionPerformed
        mnucbNU.setSelected(false);
    }//GEN-LAST:event_bSalirNUActionPerformed
    
    private void mnucbNUStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_mnucbNUStateChanged
        if (mnucbNU.isSelected()) ifUsuariosNuevos.setVisible(true);else ifUsuariosNuevos.setVisible(false);
    }//GEN-LAST:event_mnucbNUStateChanged
    
    private void iconiza(javax.swing.event.InternalFrameEvent evt) {
        
        // Resuelve el bug de swing para calcular la situacion de la primera ventana iconizada
        
        Component[] mc=escritorio.getComponents();
        Component yo = null;
        
        Rectangle re=escritorio.getBounds();
        Rectangle mirect=new Rectangle(10,10,10,10);
        Vector rectangulos=new Vector();
        
        for (int i=0;i<mc.length;i++) {
            Component c=mc[i];
            if (c instanceof JInternalFrame.JDesktopIcon) {
                JInternalFrame.JDesktopIcon jif=(JInternalFrame.JDesktopIcon)c;
                Rectangle r=c.getBounds();
                if (!evt.getInternalFrame().equals(jif.getInternalFrame())) rectangulos.add(r); else {yo=c;mirect=r;}
            }
        }
        
        if (re.height<=mirect.y+mirect.height) mirect.y=re.height-mirect.height;
        
        Enumeration renum=rectangulos.elements();
        while ( renum.hasMoreElements() ) {
            Rectangle rp=(Rectangle)renum.nextElement();
            if (superpongo(mirect,rectangulos)) {
                mirect.x=mirect.x+rp.width+1;
                if (re.width<mirect.x+mirect.width) {mirect.x=0;mirect.y=mirect.y-mirect.height;}
            } else break;
        }
        yo.setBounds(mirect);
    }
    
    boolean superpongo(Rectangle rc,Vector v) {
        Enumeration renum=v.elements();
        while ( renum.hasMoreElements() ) {
            Rectangle rp=(Rectangle)renum.nextElement();
            if (rp.intersects(rc)) return true;
        }
        return false;
    }
    
    private void ifUsuariosNuevosInternalFrameIconified(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_ifUsuariosNuevosInternalFrameIconified
        iconiza(evt);
    }//GEN-LAST:event_ifUsuariosNuevosInternalFrameIconified
    
    private void bImportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bImportarActionPerformed
        mnuImportarActionPerformed(evt);
    }//GEN-LAST:event_bImportarActionPerformed
    
    private void bSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirActionPerformed
        Salir();
    }//GEN-LAST:event_bSalirActionPerformed
    
    private void mnuRestauraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuRestauraActionPerformed
        
        JFileChooser fc=new JFileChooser();
        
        fc.setFileFilter(new FiltroBCK());
        fc.setFileView(new KemitFileView());
        fc.setDialogTitle(RESTAURAR_BCK);
        
        int ret=fc.showDialog(this,rb.getString("RESTORE"));
        
        if (ret==JFileChooser.APPROVE_OPTION) {
            File f=fc.getSelectedFile();
            try {
                mensage(INICIO_BASE_DESSERIALIZADA);
                ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
                Vector base=(Vector) in.readObject();
                in.close();
                usuariosNEW=(Vector)base.get(0);
                gruposNEW=(Vector)base.get(1);
                Enumeration enu=gruposNEW.elements();
                while (enu.hasMoreElements()) {
                    Object o=enu.nextElement();
                    if (grupos.contains(o)) gruposNEW.remove(o);
                }
                mensage(BASE_DESSERIALIZADA);
                mnuEstructuraAServer.setEnabled(true);
            } catch (Exception e) {
                mensage(ERROR_BASE_DESSERIALIZADA);
                if (debug) mensage(e);
            }
        } else {
            mensage(ERROR_BASE_DESSERIALIZADA);
        }
    }//GEN-LAST:event_mnuRestauraActionPerformed
    
    void ponerEstructuraEnServer() {
        if (chBorraGrpUsu.isSelected()) {
            for (int i=0;i<grupos.size();i++) {
                GrupoLDAP g=(GrupoLDAP) grupos.get(i);
                if (g.borrarEnServerLDAP(ss.getCtx(),this))
                    grupos.remove(g);
            }
            for (int i=0;i<usuarios.size();i++) {
                UsuarioLDAP u=(UsuarioLDAP) usuarios.get(i);
                if (!usuariosNEW.contains(u)) {
                    u.setGrupos(new Vector());
                    final UsuarioLDAP u2=u;
                    if (u.borrarEnServerLDAP(ss.getCtx(),this)) {
                        ObjectThread ts;
                        try {
                            ts = new ObjectThread(u) {
                                public void run() {
                                    unixUtil.ejecuta("tar -czf " + u2.getUid() + ".tgz " + u2.getHomeDirectory(), null, yo.dirGuargar.getText());
                                    unixUtil.ejecutaS("rm -R " + u2.getHomeDirectory(), null, yo.dirGuargar.getText());
                                    acaba();
                                }
                            };
                            ts.start();
                            usuarios.remove(u);
                        } catch (Exception ex) { ex.printStackTrace();}
                    }
                }
            }
        }
        for (int i=0;i<gruposNEW.size();i++) {
            GrupoLDAP g=(GrupoLDAP) gruposNEW.get(i);
            if (g.newLDAP(ss.getCtx(),this)) grupos.add(g);
        }
        
        for (int i=0;i<usuariosNEW.size();i++) {
            UsuarioLDAP u=(UsuarioLDAP) usuariosNEW.get(i);
            if (u.newLDAP(ss.getCtx(),this)) {
                final UsuarioLDAP u2=u;
                ObjectThread ts;
                try {
                    ts = new ObjectThread(u) {
                        public void run() {
                            String dir = yo.dirGuargar.getText();
                            if (!dir.endsWith("/"))
                                dir = dir + "/";
                            File f = new File(dir + u2.getUid() + ".tgz");
                            String home = yo.txtHome.getText();
                            if (!home.endsWith("/"))
                                home = home + "/";
                            if (f.exists()) {
                                unixUtil.ejecuta("tar -xzf "+dir + u2.getUid() + ".tgz ", null, "/");
                                unixUtil.ejecuta("rm -f "+dir + u2.getUid() + ".tgz ", null, "/");
                            } else {
                                unixUtil.ejecuta("mkdir " + home + u2.getUid() + "/", null, home);
                                try {
                                    CopyFile.copia("/etc/skel", home + u2.getUid());
                                } catch (IOException ex) {
                                }
                            }
                            unixUtil.ejecutaS("chown -R " + u2.getUid() + " " + home + u2.getUid() + "/", null, home);
                            unixUtil.ejecutaS("chgrp -R " + u2.getGidNumber() + " " + home + u2.getUid() + "/", null, home);
                            acaba();
                        }
                    };
                    ts.start();
                    usuarios.add(u);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        refrescarArbol();
    }
    
    private void mnuCopiaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuCopiaActionPerformed
        
        JFileChooser fc=new JFileChooser();
        fc.setFileFilter(new FiltroBCK());
        fc.setFileView(new KemitFileView());
        fc.setDialogTitle(REALIZAR_BCK);
        fc.setApproveButtonText(rb.getString("SAVE"));
        int ret=fc.showSaveDialog(this);
        
        if (ret==JFileChooser.APPROVE_OPTION) {
            File f=fc.getSelectedFile();
            
            if (getExtension(f).equals("") ) {
                f=new File(f.getAbsolutePath()+".bckLDAP");
            }
            if (!getExtension(fc.getName(f)).equals("BCKLDAP") ) {
                JOptionPane.showMessageDialog(this,MAL_EXTENSION_BCK,ATT,JOptionPane.ERROR_MESSAGE);
                mensage(ERROR_BASE_SERIALIZADA);
                return;
            }
            
            Vector object = new Vector();
            object.add(usuarios);
            object.add(grupos);
            
            try {
                ObjectOutput out = new ObjectOutputStream(new FileOutputStream(f));
                out.writeObject(object);
                out.close();
                mensage(BASE_SERIALIZADA);
            } catch (IOException e) {
                if (debug) mensage(e);
                mensage(ERROR_BASE_SERIALIZADA);
            }
        } else {
            mensage(CANCELAR_BASE_SERIALIZADA);
        }
        
    }//GEN-LAST:event_mnuCopiaActionPerformed
    
    private void mnuImportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuImportarActionPerformed
        
        JFileChooser fc=new JFileChooser();
        
        fc.setFileFilter(new FiltroXML());
        fc.setFileView(new KemitFileView());
        
        fc.setDialogTitle(IMPORTAR_FICHERO);
        fc.setApproveButtonText(rb.getString("IMPORT"));
        
        int ret=fc.showOpenDialog(this);
        
        if (ret==JFileChooser.APPROVE_OPTION) {
            final JFileChooser fc2=fc;
            
            Thread ts=new Thread() {
                public void run() {
                    barra.setValue(0);
                    barra.setMaximum(10);
                    mensageOp(BCON_SERVIDOR);
                    barra.setValue(1);
                    refrescarArbol();
                    barra.setValue(2);
                    dlm_borrar=new DefaultListModel();
                    listaUsuariosBorrar.setModel(dlm_borrar);
                    dlm_igual=new DefaultListModel();
                    listaUsuariosIgual.setModel(dlm_igual);
                    dlm_new=new DefaultListModel();
                    listaNuevosUsuarios.setModel(dlm_new);
                    
                    usuariosNEW=new Vector();
                    gruposNEW=new Vector();
                    
                    File f=fc2.getSelectedFile();
                    if (getExtension(f).equals("XML")) {
                        try {
                            barra.setValue(3);
                            Object o= FileParser.parseXmlFile(f.getAbsolutePath(), false);
                            barra.setValue(4);
                            if (o instanceof Document) {
                                Document doc=(Document) o;
                                usuariosNEW=FileParser.usuariosXML(doc,ss.getCtx(),yo);
                                barra.setValue(7);
                                mensage(IMPORTAR_FICHERO_OK);
                            } else {
                                throw new KemitParserException("Documento mal formado");
                            }
                        } catch (KemitParserException ex) {
                            if (debug) mensage(ex);
                            mensage(IMPORTAR_FICHERO_MAL);
                        } catch (Exception ex) {
                            if (debug) mensage(ex);
                            mensage(IMPORTAR_FICHERO_MAL);
                        }
                    } else if (getExtension(f).equals("CSV") || getExtension(f).equals("TXT")) {
                        try {
                            FileParser.setColgrupo(false);
                            usuariosNEW=FileParser.parseCSVFile(f.getAbsolutePath(),ss.getCtx(),yo);
                            barra.setValue(7);
                        } catch (KemitParserException ex) {
                            if (debug) mensage(ex);
                            mensage(IMPORTAR_FICHERO_MAL);
                            mensage("Error en linea:"+FileParser.getLinea());
                        } catch (Exception ex) {
                            if (debug) mensage(ex);
                            mensage(IMPORTAR_FICHERO_MAL);
                            mensage("Error en linea:"+FileParser.getLinea());
                        }
                    }
                    barra.setValue(8);
                    if (usuariosNEW==null ) {
                        JOptionPane.showMessageDialog(yo,NO_HAY_NUEVOS_USUARIOS,ATT,JOptionPane.ERROR_MESSAGE);
                        mensage(NO_HAY_NUEVOS_USUARIOS);
                        mensageOp(NO_HAY_NUEVOS_USUARIOS);
                    } else if (usuariosNEW.size()==0  ) {
                        JOptionPane.showMessageDialog(yo,NO_HAY_NUEVOS_USUARIOS,ATT,JOptionPane.ERROR_MESSAGE);
                        mensage(NO_HAY_NUEVOS_USUARIOS);
                    } else {
                        barra.setValue(9);
                        generarListas();
                        barra.setValue(10);
                    }
                    dlgAvances.setVisible(false);
                }
            };
            ts.start();
            dlgAvances.setVisible(true);
        } else {
            mensage(CANCELAR_IMPORTAR_FICHERO);
        }
        
    }//GEN-LAST:event_mnuImportarActionPerformed
    
    private void bmsgSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bmsgSalirActionPerformed
        mnucbMensages.setSelected(false);
    }//GEN-LAST:event_bmsgSalirActionPerformed
    
    private void dlgLoginWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_dlgLoginWindowClosing
        Salir();
    }//GEN-LAST:event_dlgLoginWindowClosing
    
    private void mnuSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuSalirActionPerformed
        Salir();
    }//GEN-LAST:event_mnuSalirActionPerformed
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        Salir();
    }//GEN-LAST:event_formWindowClosing
    
    private void passwordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_passwordActionPerformed
        //bEntrarLogin.requestFocus();
        bEntrarLoginActionPerformed(null);
    }//GEN-LAST:event_passwordActionPerformed
    
    private void bEntrarLoginKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_bEntrarLoginKeyReleased
        if (evt.getKeyCode()==KeyEvent.VK_ENTER) {
            bEntrarLoginActionPerformed(null);
        }
    }//GEN-LAST:event_bEntrarLoginKeyReleased
    
    public String userPasswordToString(byte[] pwd) {
        String s="";
        for (int i=0;i<pwd.length;i++) {
            s+=(char)pwd[i];
        }
        //System.out.println(" "+s);
        return s;
    }
    
    void visitNodes(DefaultMutableTreeNode oldNodes,DefaultMutableTreeNode newNodes ){
        
        java.util.List lista=Collections.list(oldNodes.children());
        Collections.sort(lista);
        
        for (int i = 0; i < lista.size(); i++) {
            DefaultMutableTreeNode chNode = new DefaultMutableTreeNode(lista.get(i));
            newNodes.add(chNode);
            visitNodes((DefaultMutableTreeNode)lista.get(i),chNode);
        }
        
        
    }
    
    
    public void llenaUsuariosDesdeLDAP() throws NamingException {
        mensageOp(RECUPERANDO_USUARIOS);
        usuarios=new Vector();
        maxUID=1000;
        NamingEnumeration people = ss.getCtx().search("ou=people",null);
        while (people.hasMore()) {
            UsuarioLDAP u=new UsuarioLDAP((SearchResult)people.next());
            if (!u.getDisplayName().equals("root")) {
                try {
                    Integer uidNumber=new Integer(u.getUidNumber());
                    if (uidNumber.intValue()>maxUID) maxUID=uidNumber.intValue();
                    nodoUsuarios.add(new DefaultMutableTreeNode(u));
                    usuarios.add(u);
                    dlm_usu.addElement(u);
                    mensageOp(""+u);
                } catch (Exception ie) {
                    if (debug) mensage(ie);
                }
            }
        }
        maxUID=maxNUIDInUnix(maxUID);
        mensageOp(FIN_RECUPERANDO_USUARIOS);
    }
    
    public void llenaGruposDesdeLDAP() throws NamingException {
        mensageOp(RECUPERANDO_GRUPOS);
        grupos=new Vector();
        maxGID=1000;
        dlm_gu.removeAllElements();
        NamingEnumeration groups = ss.getCtx().search("ou=group",null);
        versionLINKAT=1;
        while (groups.hasMore()) {
            GrupoLDAP g=new GrupoLDAP(usuarios, (SearchResult)groups.next());
            if (g.getCn().equals("users")) {
                versionLINKAT=2;
                grp_users=g;
            }
            try {
                Integer gidNumber=new Integer(g.getGidNumber());
                if (gidNumber.intValue()>maxGID) maxGID=gidNumber.intValue();
                g.setSelected(false);
                grupos.add(g);
                mensage(""+g);
                dlm_gu.addElement(g);
                DefaultMutableTreeNode dmt=new DefaultMutableTreeNode(g);
                Enumeration e=g.getMiembros().elements();
                while (e.hasMoreElements()) {
                    dmt.add(new DefaultMutableTreeNode(e.nextElement()));
                }
                nodoGrupos.add(dmt);
                cbGrupos.addElement(g);
            } catch (Exception ie) {
                
            }
        }
        maxGID=maxGIDInUnix(maxGID);
        //dlm_gu.addElement(unix_grp_group);
        mensageOp(FIN_RECUPERANDO_GRUPOS);
    }
    
    private void comprueba_esquema() throws NamingException {
        mensage(COMPROBANDO_ESQUEMA_SAGA);
        
        if (OpenLdapUtil.isSamba()) {
            mensage("Schema SAMBA OK");
            setSAMBA(1);
        } else {
            mensage("Schema SAMBA not present");
            setSAMBA(0);
            mensage("Add Schema SAMBA");
            OpenLdapUtil.anyadeSamba();
            mensage(REINCIANDO_SERVIDOR);
            OpenLdapUtil.rebotaLDAP();
            mensage(CONECTANDO_SERVIDOR);
            ss=new Session(ss.getPwd());
        }
        //comprobar el esquema samba
        SambaDomain sd=new SambaDomain(ss.getCtx());
        if (sd.getSambaDomainName().equals("")) throw new NamingException("samba-ldap link not initiated");
        
        if ( OpenLdapUtil.isEsquemaSAGA(ss.getCtx()) ) {
            mensage(ESQUEMA_SAGA_CORRECTO);
        } else {
            mensage(ESQUEMA_SAGA_INCORRECTO);
            ss.getCtx().close();
            mensage(ANYADO_ESQUEMA_SAGA);
            OpenLdapUtil.anyadeEsquemaSAGA();
            mensage(REINCIANDO_SERVIDOR);
            OpenLdapUtil.rebotaLDAP();
            mensage(CONECTANDO_SERVIDOR);
            ss=new Session(ss.getPwd());
            if ( OpenLdapUtil.isEsquemaSAGA(ss.getCtx()) ) mensage(ESQUEMA_SAGA_CORRECTO); else mensage(ESQUEMA_SAGA_INCORRECTO);
        }
        
    }
    
    
    
    private void bEntrarLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bEntrarLoginActionPerformed
        
        String pwd=new String(password.getPassword());
        if (pwd.equals("")) {
            intentos++;
            if (intentos>3) {
                mensage(DEMASIADOS_INTENTOS);
                JOptionPane.showMessageDialog(this,DEMASIADOS_INTENTOS,ATT,JOptionPane.ERROR_MESSAGE);
                Salir();
            }
            JOptionPane.showMessageDialog(this,INTRODUCIR_LOGIN,ATT,JOptionPane.ERROR_MESSAGE);
            java.awt.EventQueue.invokeLater(new Runnable() {public void run() {password.requestFocus();}});
            return;
        }
        Session ss=new Session(pwd);
        
        if (ss.getCtx()!=null) {
            yo.setSs(ss);
            yo.setVisible(true);
            dlgLogin.setVisible(false);
            try {
                mensage(ADMINISTRADOR_LOGIN);
                Thread ts=new Thread() {
                    public void run() {
                        try {
                            comprueba_esquema();
                            mensage(GRP_UTIL);
                            llenaUsuariosDesdeLDAP();
                            llenaGruposDesdeLDAP();
                            arbol.doLayout();
                            arbol.repaint();
                            txtDC.setText(txtDC1.getText());
                            txtUserAdmin.setText(txtUserAdmin1.getText());
                            grabaPrefs();
                        } catch (Exception e) {
                            if (debug) mensage(e);
                        }
                    }
                };
                try {ts.start();} catch (Exception e) {if (debug) mensage(e);}
            } catch (Exception ex) {
                if (debug) mensage(ex);
            }
        } else if ( (ss.getEx() instanceof javax.naming.AuthenticationException ) ){
            mensage(USUARIO_INCORRECTO);
            JOptionPane.showMessageDialog(this,USUARIO_INCORRECTO,ATT,JOptionPane.ERROR_MESSAGE);
            password.setText("");
            intentos++;
            if (intentos>3) {
                mensage(DEMASIADOS_INTENTOS);
                JOptionPane.showMessageDialog(this,DEMASIADOS_INTENTOS,ATT,JOptionPane.ERROR_MESSAGE);
                Salir();
            }
            java.awt.EventQueue.invokeLater(new Runnable() {public void run() {password.requestFocus();}});
        } else if ( (ss.getEx() instanceof javax.naming.CommunicationException ) ){
            mensage(ERROR_COMUNICACIONES);
            JOptionPane.showMessageDialog(this,ERROR_COMUNICACIONES,ATT,JOptionPane.ERROR_MESSAGE);
            password.setText("");
            java.awt.EventQueue.invokeLater(new Runnable() {public void run() {password.requestFocus();}});
        }
        
    }//GEN-LAST:event_bEntrarLoginActionPerformed
    
    private void bCancelLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelLoginActionPerformed
        mensage(CANCELAR_LOGIN);
        Salir();
    }//GEN-LAST:event_bCancelLoginActionPerformed
    
    private void bMarcarUI1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMarcarUI1ActionPerformed
        Enumeration enumeracion=dlm_usu.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(true);
        }
        listaUsuarios.repaint();
        ifEditGroup.repaint();
    }//GEN-LAST:event_bMarcarUI1ActionPerformed
    
    private void bDesmarcarUI1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDesmarcarUI1ActionPerformed
        Enumeration enumeracion=dlm_usu.elements();
        while (enumeracion.hasMoreElements()) {
            UsuarioLDAP u=(UsuarioLDAP)enumeracion.nextElement();
            u.setSelected(false);
        }
        listaUsuarios.repaint();
        ifEditGroup.repaint();
    }//GEN-LAST:event_bDesmarcarUI1ActionPerformed
    
    private void bMUsu1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bMUsu1ActionPerformed
        GrupoLDAP g=g_grupo_actual;
        for (int i=0;i<dlm_usu.size();i++) {
            UsuarioLDAP u=(UsuarioLDAP) dlm_usu.elementAt(i);
            DefaultMutableTreeNode minodo=null;
            for (int j=0;j<nodoGrupos.getChildCount();j++) {
                DefaultMutableTreeNode dmtn=(DefaultMutableTreeNode) nodoGrupos.getChildAt(j);
                if (dmtn.getUserObject().equals(g)) minodo=dmtn;
            }
            if (u.isSelected()  ) {
                if (!g.getMiembros().contains(u)) {
                    u.masGrupos(g);
                    g.masMiembros(u.getUid(),u);
                    try {
                        g.addMemberLDAP(ss.getCtx(),u,txtDC.getText());
                        if (minodo!=null) minodo.add(new DefaultMutableTreeNode(u));
                    } catch (NamingException ne) {
                        mensage("Not add member in group "+g);
                        mensage(ne);
                    }
                }
            } else {
                u.menosGrupos(g);
                g.menosMiembros(u.getUid());
                g.minusMemberLDAP(ss.getCtx(),u,txtDC.getText());
                DefaultMutableTreeNode minodo2=null;
                for (int j=0;j<minodo.getChildCount();j++) {
                    DefaultMutableTreeNode dmtn=(DefaultMutableTreeNode) minodo.getChildAt(j);
                    if (dmtn.getUserObject().equals(u)) minodo2=dmtn;
                }
                if (minodo!=null && minodo2!=null) minodo.remove(minodo2);
            }
        }
        dtm.reload();
        arbol.repaint();
        if (ifEditUser.isVisible()) {
            llenaifEditUser();
            ifEditUser.repaint();
        }
    }//GEN-LAST:event_bMUsu1ActionPerformed
    
    
    void Salir() {
        mensage(SALIENDO_SISTEMA);
        try {
            if (getSs()!=null) {
                if (getSs().getCtx()!=null) getSs().getCtx().close();
            }
        } catch (NamingException ne) {}
        System.exit(0);
    }
    
    
    public static boolean contains(Preferences node, String key) {
        return node.get(key, null) != null;
    }
    
    
    public void cargaPrefs()  {
        txtUserAdmin.setText(preferencias.get(pUsuario,"Administrator"));
        txtDC.setText(preferencias.get(pDominio,"intracentre"));
        listaAlgoritmos.setSelectedIndex(preferencias.getInt(pAlgoritmo, 1));
        chConservarHome.setSelected(preferencias.getBoolean(pGuardaHomes, true));
        dirGuargar.setText(preferencias.get(pDirGuardaHomes,"/root"));
        chDebug.setSelected(preferencias.getBoolean(pDebug, false));
        txtShell.setText(preferencias.get(pShell,"/bin/bash"));
        txtHome.setText(preferencias.get(pHome,"/home"));
        chBorraGrpUsu.setSelected(preferencias.getBoolean(pLimpiarActual, false));
        chGrupUsers.setSelected(preferencias.getBoolean(pGrupUsers, true));
    }
    
    public void grabaPrefs()  {
        preferencias.put(pUsuario, txtUserAdmin.getText());
        preferencias.put(pDominio, txtDC.getText());
        preferencias.putInt(pAlgoritmo, listaAlgoritmos.getSelectedIndex());
        preferencias.putBoolean(pGuardaHomes, chConservarHome.isSelected());
        preferencias.put(pDirGuardaHomes,dirGuargar.getText());
        preferencias.putBoolean(pDebug,chDebug.isSelected());
        preferencias.put(pShell,txtShell.getText());
        preferencias.put(pHome,txtHome.getText());
        preferencias.putBoolean(pLimpiarActual,chBorraGrpUsu.isSelected());
        preferencias.putBoolean(pGrupUsers,chGrupUsers.isSelected());
    }
    
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        
        Frame splashFrame = null;
        URL imageURL = Principal.class.getResource("/imagenes/GUS_def_01.png");
        if (imageURL != null) {
            splashFrame = SplashWindow.splash(Toolkit.getDefaultToolkit().createImage(imageURL));
        } else {
            System.err.println("Splash image not found");
        }
        final Frame sp=splashFrame;
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                yo=new Principal();
                try {
                    Thread.sleep(3000);
                    yo.cargaPrefs();
                    yo.txtUserAdmin1.setText(yo.txtUserAdmin.getText());
                    yo.txtDC1.setText(yo.txtDC.getText());
                    yo.login();
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
                if (sp != null) sp.dispose();
            }
        });
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTree arbol;
    private javax.swing.JButton bAG;
    private javax.swing.JButton bAUsu;
    private javax.swing.JButton bBorrarMsg;
    private javax.swing.JButton bBorrarU;
    private javax.swing.JButton bBuscar;
    private javax.swing.JButton bCancelLogin;
    private javax.swing.JButton bCancelarOperaciones;
    private javax.swing.JButton bCancelarPref;
    private javax.swing.JButton bCascade;
    private javax.swing.JButton bDefectos;
    private javax.swing.JButton bDesmarcarUB;
    private javax.swing.JButton bDesmarcarUI;
    private javax.swing.JButton bDesmarcarUI1;
    private javax.swing.JButton bDesmarcarUN;
    private javax.swing.JButton bDirDef;
    private javax.swing.JButton bEntrarLogin;
    private javax.swing.JButton bGrabarPref;
    private javax.swing.JButton bGuardarLog;
    private javax.swing.JButton bImportar;
    private javax.swing.JButton bMUsu;
    private javax.swing.JButton bMUsu1;
    private javax.swing.JButton bMarcarUB;
    private javax.swing.JButton bMarcarUI;
    private javax.swing.JButton bMarcarUI1;
    private javax.swing.JButton bMarcarUN;
    private javax.swing.JButton bPasasB;
    private javax.swing.JButton bRefrescar;
    private javax.swing.JButton bSEG;
    private javax.swing.JButton bSEG1;
    private javax.swing.JButton bSalir;
    private javax.swing.JButton bSalirNU;
    private javax.swing.JButton bSalirPref;
    private javax.swing.JButton bSalirUB;
    private javax.swing.JButton bSalirUI;
    private javax.swing.JProgressBar barra;
    private javax.swing.JButton bgrupdefecto;
    private javax.swing.JButton bgrupsel;
    private javax.swing.JButton binsertarNU;
    private javax.swing.JButton bmsgSalir;
    private javax.swing.JButton bsalirAbout;
    private javax.swing.JComboBox cbGrupPrincipal;
    private javax.swing.JCheckBox chBorraGrpUsu;
    public javax.swing.JCheckBox chConservarHome;
    private javax.swing.JCheckBox chDebug;
    private javax.swing.JCheckBox chGrupUsers;
    private javax.swing.JPanel derPanel;
    public javax.swing.JLabel dirGuargar;
    private javax.swing.JDialog dlgAbout;
    private javax.swing.JDialog dlgAvances;
    private javax.swing.JDialog dlgGrupo;
    private javax.swing.JDialog dlgLogin;
    private javax.swing.JDialog dlgPreferencias;
    private javax.swing.JDesktopPane escritorio;
    private javax.swing.JInternalFrame ifEditGroup;
    private javax.swing.JInternalFrame ifEditUser;
    private javax.swing.JInternalFrame ifMensages;
    private javax.swing.JInternalFrame ifUsuariosBorrar;
    private javax.swing.JInternalFrame ifUsuariosIgual;
    private javax.swing.JInternalFrame ifUsuariosNuevos;
    private javax.swing.JLabel imgKemit;
    private javax.swing.JPanel izqPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenuBar jMenuBar;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSplitPane jSplitPane1;
    private kemit.component.KCheckBoxJList kCheckBoxJList1;
    private javax.swing.JLabel lineaMsg;
    private javax.swing.JList listGruposAlta;
    private javax.swing.JComboBox listaAlgoritmos;
    private javax.swing.JMenu mnuBackUp;
    private javax.swing.JMenuItem mnuCopia;
    private javax.swing.JMenuItem mnuEstructuraAServer;
    private javax.swing.JMenu mnuFichero;
    private javax.swing.JMenuItem mnuImportar;
    private javax.swing.JMenu mnuOperaciones;
    private javax.swing.JMenuItem mnuPreferncias;
    private javax.swing.JMenuItem mnuRestaura;
    private javax.swing.JMenuItem mnuSalir;
    private javax.swing.JMenu mnuVentanas;
    private javax.swing.JMenuItem mnuVersion;
    private javax.swing.JCheckBoxMenuItem mnucbMensages;
    private javax.swing.JCheckBoxMenuItem mnucbNU;
    private javax.swing.JCheckBoxMenuItem mnucbUQNC;
    private javax.swing.JCheckBoxMenuItem mnucbUaB;
    private javax.swing.JTextArea msgOperaciones;
    private javax.swing.JTextArea msgTxtArea;
    private javax.swing.JMenuItem pBorrar;
    private javax.swing.JMenuItem pBorrarN;
    private javax.swing.JPanel pBotones;
    private javax.swing.JPanel pBotonesNU;
    private javax.swing.JPanel pBotonesNU1;
    private javax.swing.JPanel pBotonesNU2;
    private javax.swing.JMenuItem pEditar;
    private javax.swing.JMenuItem pEditarN;
    private javax.swing.JPasswordField password;
    private javax.swing.JPopupMenu pmUsu;
    private javax.swing.JPanel pmsg;
    private javax.swing.JScrollPane scollArbol;
    private javax.swing.JScrollPane scrollG;
    private javax.swing.JToolBar toolBar;
    private javax.swing.JTextField txtBusqueda;
    public javax.swing.JTextField txtCNOM;
    public javax.swing.JTextField txtDC;
    public javax.swing.JTextField txtDC1;
    public javax.swing.JTextField txtHome;
    public javax.swing.JTextField txtHomeUsu;
    public javax.swing.JTextField txtNOM;
    private javax.swing.JTextField txtNomGrup;
    private javax.swing.JTextField txtNomUsu;
    private javax.swing.JPasswordField txtPwd1;
    private javax.swing.JPasswordField txtPwd2;
    public javax.swing.JTextField txtSagaID;
    public javax.swing.JTextField txtShell;
    public javax.swing.JTextField txtShellUsu;
    public javax.swing.JTextField txtUID;
    public javax.swing.JTextField txtUserAdmin;
    public javax.swing.JTextField txtUserAdmin1;
    // End of variables declaration//GEN-END:variables
    
    
    
    
    
    
    
    
    
    
    
    
    // ******************************************************************************************
    // Clases utilitarias
    // ******************************************************************************************
    
    
    public class focusLogin extends FocusTraversalPolicy {
        
        public Component getComponentAfter(Container focusCycleRoot,Component aComponent) {
            
            if (aComponent.equals(password)) {return bEntrarLogin;} else if (aComponent.equals(bEntrarLogin)) {return bCancelLogin;} else if (aComponent.equals(bCancelLogin)) {return password;}
            return password;
        }
        
        public Component getComponentBefore(Container focusCycleRoot,Component aComponent) {
            if (aComponent.equals(password)) {return bCancelLogin;} else if (aComponent.equals(bEntrarLogin)) {return password;} else if (aComponent.equals(bCancelLogin)) {return bEntrarLogin;}
            return password;
        }
        
        public Component getDefaultComponent(Container focusCycleRoot) {
            return password;
        }
        
        public Component getLastComponent(Container focusCycleRoot) {
            return bCancelLogin;
        }
        
        public Component getFirstComponent(Container focusCycleRoot) {return password;}
        
    }
    
    public class Session {
        
        private DirContext ctx;
        private Hashtable env;
        private String pwd;
        private Exception ex;
        
        public Session(String pwd) {
            this.pwd=pwd;
            env = new Hashtable();
            env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory");
            if (System.getProperty("os.name").toLowerCase().indexOf("win")>=0) {
                env.put(Context.PROVIDER_URL, "ldap://192.168.1.123:389/dc="+txtDC1.getText());
                yo.mensage("windows");
            } else if (System.getProperty("os.name").toLowerCase().indexOf("mac os x")>=0) {
                env.put(Context.PROVIDER_URL, "ldap://192.168.1.123:389/dc="+txtDC1.getText());
                yo.mensage("windows");
                
            } else {
                env.put(Context.PROVIDER_URL, "ldap://localhost:389/dc="+txtDC1.getText());
            }
            env.put(Context.SECURITY_AUTHENTICATION, "simple");
            env.put(Context.SECURITY_PRINCIPAL, "cn="+txtUserAdmin1.getText()+",dc="+txtDC1.getText());
            env.put(Context.SECURITY_CREDENTIALS, pwd);
            env.put("java.naming.ldap.version", "3");
            
            try {
                setCtx(new InitialDirContext(env));
                setEx(null);
            } catch (Exception e) {
                setCtx(null);
                setEx(e);
            }
        }
        
        public DirContext getCtx() { return ctx;}
        public void setCtx(DirContext ctx) {this.ctx = ctx;}
        
        public Exception getEx() {return ex;}
        public void setEx(Exception ex) {this.ex = ex;}
        
        public Hashtable getEnv() {return env;}
        
        public void setEnv(Hashtable env) {this.env = env;}
        
        public String getPwd() {return pwd;}
        
    }
    
    public class arbolRenderer extends DefaultTreeCellRenderer {
        
        JLabel jl=new JLabel();
        
        ImageIcon ico_root=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/environment32.png")));
        
        ImageIcon ico_usu=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/id_card32.png")));
        ImageIcon ico_grp=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/businessmen32.png")));
        
        ImageIcon ico_usup=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/id_card24.png")));
        ImageIcon ico_grpp=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/businessmen24.png")));
        
        ImageIcon ico_usub=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/usuarioborrado.png")));
        ImageIcon ico_grpb=new ImageIcon(Toolkit.getDefaultToolkit().createImage(getClass().getResource("/imagenes/grupoborrado24.png")));
        
        
        
        public Component getTreeCellRendererComponent(JTree tree,Object value,boolean sel,boolean expanded,boolean leaf,int row,boolean hasFocus) {
            
            Color selback=Color.ORANGE;
            Color selfore=Color.BLACK;
            Color borrado=Color.GRAY;
            Color blanco=Color.WHITE;
            
            DefaultMutableTreeNode v2=(DefaultMutableTreeNode) value;
            Object objeto=v2.getUserObject();
            
            jl.setBackground(arbol.getBackground());jl.setForeground(arbol.getForeground());
            if (objeto instanceof UsuarioLDAP) {
                UsuarioLDAP u=(UsuarioLDAP) objeto;
                if (u.getCn().equals("")) jl.setText(u.getDisplayName()); else jl.setText(u.getCn());
                jl.setIcon(ico_usup);
                if (sel) {
                    jl.setBackground(selback); jl.setForeground(selfore);
                }
                if (u.isBorrado()) {
                    jl.setIcon(ico_usub);
                    jl.setBackground(blanco); jl.setForeground(borrado);
                }
            } else if (objeto instanceof GrupoLDAP) {
                GrupoLDAP g=(GrupoLDAP) objeto;
                jl.setText(g.getCn());
                jl.setIcon(ico_grpp);
                if (sel) {
                    jl.setBackground(selback); jl.setForeground(selfore);
                }
                if (g.isBorrado()) {
                    jl.setIcon(ico_grpb);
                    jl.setBackground(blanco); jl.setForeground(borrado);
                }
            } else {
                if (sel) {
                    jl.setBackground(selback); jl.setForeground(selfore);
                }
                if (value.equals(nodoUsuarios)) {
                    jl.setIcon(ico_usu);
                    jl.setText(USUARIOS);
                } else if (value.equals(nodoGrupos)) {
                    jl.setIcon(ico_grp);
                    jl.setText(GRUPOS);
                } else if (value.equals(raiz)) {
                    jl.setIcon(ico_root);
                    jl.setText(RAIZ);
                } else {
                    setToolTipText(null);
                }
            }
            
            
            jl.setOpaque(true);
            return jl;
        }
        
        
    }
    
    class FiltroXML extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName().toLowerCase();
            if (file.isDirectory()) return true;
            return filename.endsWith(".xml") || filename.endsWith(".csv") || filename.endsWith(".txt") ;
        }
        public String getDescription() {
            return "*.xml";
        }        
    }
    
    class FiltroBCK extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            if (file.isDirectory()) return true;
            return filename.endsWith(".bckLDAP");
        }
        public String getDescription() {
            return "*.bckLDAP";
        }
    }
    
    class FiltroLOG extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            if (file.isDirectory()) return true;
            return filename.toLowerCase().endsWith(".log");
        }
        public String getDescription() {
            return "*.log";
        }
    }
    
    class FiltroPDF extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            if (file.isDirectory()) return true;
            return filename.toLowerCase().endsWith(".pdf");
        }
        public String getDescription() {
            return "*.pdf";
        }
    }
    
    
    class KemitLogFileView extends javax.swing.filechooser.FileView {
        
        ImageIcon ico_bck=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/cookies24.png")));
        ImageIcon ico_xml=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_up.png")));
        ImageIcon ico_csv=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/calc_icon.jpg")));
        ImageIcon ico_txt=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_text.png")));
        ImageIcon ico_xls=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_up.png")));
        ImageIcon ico_log=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/history2.png")));
        
        public Icon getIcon(File f) {
            
            String extension = getExtension(f);
            Icon icon = null;
            
            if (extension != null) {
                if (extension.equals("BCKLDAP")) icon = ico_bck;
                else if (extension.equals("XML")) icon = ico_xml;
                else if (extension.equals("CSV")) icon = ico_csv;
                else if (extension.equals("TXT")) icon = ico_txt;
                else if (extension.equals("XLS")) icon = ico_xls;
                else if (extension.equals("LOG")) icon = ico_log;
            }
            return icon;
        }
        
    }
    
    class KemitFileView extends javax.swing.filechooser.FileView {
        
        ImageIcon ico_bck=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/cookies24.png")));
        ImageIcon ico_xml=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_up.png")));
        ImageIcon ico_csv=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/calc_icon.jpg")));
        ImageIcon ico_txt=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_text.png")));
        ImageIcon ico_xls=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/document_up.png")));
        
        public Icon getIcon(File f) {
            
            String extension = getExtension(f);
            Icon icon = null;
            
            if (extension != null) {
                if (extension.equals("BCKLDAP")) icon = ico_bck;
                else if (extension.equals("XML")) icon = ico_xml;
                else if (extension.equals("CSV")) icon = ico_csv;
                else if (extension.equals("TXT")) icon = ico_txt;
                else if (extension.equals("XLS")) icon = ico_xls;
            }
            return icon;
        }
        
    }
    
    class KemitFilePDFView extends javax.swing.filechooser.FileView {
        
        ImageIcon ico_pdf=new ImageIcon(Toolkit.getDefaultToolkit().createImage(arbolRenderer.class.getResource("/imagenes/pdf24.gif")));
        
        public Icon getIcon(File f) {
            
            String extension = getExtension(f);
            Icon icon = null;
            
            if (extension != null) {
                if (extension.equals("PDF")) icon = ico_pdf;
            }
            return icon;
        }
        
    }
    
    
    class arbolSelectionListener implements TreeSelectionListener {
        
        JTree arbol;
        
        public arbolSelectionListener(JTree arbol) {
            this.arbol=arbol;
        }
        
        public void valueChanged(TreeSelectionEvent evt) {
            
            DefaultMutableTreeNode nodo = (DefaultMutableTreeNode) arbol.getLastSelectedPathComponent();
            
            if (nodo == null) return;
            
            Object nodeInfo = nodo.getUserObject();
            if (debug) {
                if (nodeInfo instanceof UsuarioLDAP) {
                    //System.out.println(nodeInfo.toString());
                }
                if (nodeInfo instanceof GrupoLDAP) {
                    //System.out.println(nodeInfo.toString());
                }
            }
        }
        
    }
    
    
    // ******************************************************************************************
    // Setters y Getters
    // ******************************************************************************************
    
    public Session getSs() {
        return ss;
    }
    
    
    public void setSs(Session ss) {
        this.ss = ss;
    }
    
    // ***************************************************************************************************
    
    private void mensage(String msg) {
        if (msg==null) return;
        String pr="";
        GregorianCalendar gc=new GregorianCalendar();
        SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        try { pr=df.format(gc.getTime())+" - "+msg+"\n"; } catch (Exception e) {e.printStackTrace();}
        
        lineaMsg.setText(msg);
        if (!msg.equals("")) msgTxtArea.append(pr);
    }
    
    public void setBarra(int i) {
        barra.setValue(i);
    }
    
    public int getBarra() {
        return barra.getValue();
    }
    
    public void mensageOp(String msg) {
        if (msg==null) return;
        String pr="";
        GregorianCalendar gc=new GregorianCalendar();
        SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        try { pr=df.format(gc.getTime())+" - "+msg+"\n"; } catch (Exception e) {e.printStackTrace();}
        
        if (!msg.equals("")) {
            msgOperaciones.append(pr);
            msgTxtArea.append(pr);
        }
    }
    
    public void mensage(Exception e) {
        if (e==null) return;
        
        StringWriter sw=new StringWriter();
        e.printStackTrace(new PrintWriter(sw));
        mensage(sw.toString());
    }
    
    public String getExtension(File f) {
        String ext = "";
        String s = f.getName();
        int i = s.lastIndexOf('.');
        
        if (i > 0 &&  i < s.length() - 1)
            ext = s.substring(i+1).toUpperCase();
        return ext;
    }
    
    public String getExtension(String s) {
        String ext = "";
        int i = s.lastIndexOf('.');
        
        if (i > 0 &&  i < s.length() - 1)
            ext = s.substring(i+1).toUpperCase();
        return ext;
    }
    
    private void generarListas() {
        
        Enumeration enumera=usuariosNEW.elements();
        
        while (enumera.hasMoreElements()) {
            UsuarioLDAP usu=(UsuarioLDAP) enumera.nextElement();
            // if usuario en LDAP y en fichro a la lista iguales
            if ( usuarios.contains(usu) ) {
                UsuarioLDAP ua=null;
                for (int i=0;i<usuarios.size();i++) {
                    ua=(UsuarioLDAP) usuarios.get(i);
                    if (usu.equals(ua)) break;
                }
                if (ua!=null) dlm_igual.addElement(ua);
                usuarios.remove(usu);
            }
            // if usuario en fichero a la de nuevos
            else dlm_new.addElement(usu);
        }
        // if usuario en LDAP y no en fichero  la de borrados
        
        Enumeration borrar=usuarios.elements();
        while (borrar.hasMoreElements()) {
            UsuarioLDAP usu=(UsuarioLDAP) borrar.nextElement();
            usu.setSelected(false);
            dlm_borrar.addElement(usu);
        }
        ifUsuariosIgual.setLocation(new Point(15,15));
        ifUsuariosBorrar.setLocation(new Point(45,45));
        ifUsuariosNuevos.setLocation(new Point(75,75));
        
        mnucbUQNC.setEnabled(true);
        mnucbUaB.setEnabled(true);
        mnucbNU.setEnabled(true);
        
        mnucbUQNC.setSelected(true);
        mnucbUaB.setSelected(true);
        mnucbNU.setSelected(true);
        ifUsuariosNuevos.toFront();
        
        bCancelarOperaciones.setEnabled(true);
    }
    
    public int maxNUIDInUnix(int maxN) {
        Vector v=unixUsers;
        int maxL=maxN;
        if (v==null) return maxL;
        for (int i=0;i<v.size();i++) {
            unixUtil.unixUser usu=(unixUtil.unixUser) v.get(i);
            Integer nuid=new Integer(usu.getUidNumber());
            if (nuid.intValue()<50000) {
                if (nuid.intValue()>maxL)
                    maxL=nuid.intValue();
            }
        }
        return maxL;
    }
    
    public int maxGIDInUnix(int maxN) {
        Vector v=unixGroups;
        int maxL=maxN;
        if (v==null) return maxL;
        for (int i=0;i<v.size();i++) {
            unixUtil.unixGroup grp=(unixUtil.unixGroup) v.get(i);
            if (grp.getCn().equals("users")) {
                unix_grp_group=grp;
                cbGrupos.addElement(grp);
            }
            int mui=new Integer(grp.getGidNumber()).intValue();
            if (mui>maxL && mui<50000) maxL=mui;
        }
        return maxL;
    }
    
    public boolean isUidInUnix(String uid) {
        Vector v=unixUsers;
        if (v==null) return false;
        for (int i=0;i<v.size();i++) {
            unixUtil.unixUser usu=(unixUtil.unixUser) v.get(i);
            if (usu.getUid().equals(uid)) return true;
        }
        return false;
    }
    
    public boolean isUidInUsers(String uid) {
        Vector v=usuarios;
        if (v==null) return false;
        for (int i=0;i<v.size();i++) {
            UsuarioLDAP usu=(UsuarioLDAP) v.get(i);
            if (usu.getUid().equals(uid)) return true;
        }
        return false;
    }
    
    public boolean isUidInNewUsers(String uid) {
        Vector v=usuariosNEW;
        if (v==null) return false;
        for (int i=0;i<v.size();i++) {
            UsuarioLDAP usu=(UsuarioLDAP) v.get(i);
            if (usu.getUid().equals(uid)) return true;
        }
        return false;
    }
    
    public void localizeJFileChooser() {
        Locale lo=Locale.getDefault();
        if (lo.getLanguage().equals("ca")) {
            UIManager.put("FileChooser.fileNameLabelText",rb.getString("MNU_FICHERO"));
            UIManager.put("FileChooser.cancelButtonText",rb.getString("CANCELAR"));
            UIManager.put("FileChooser.cancelButtonToolTipText",rb.getString("CANCEL_TOOLTIP"));
            UIManager.put("FileChooser.lookInLabelText", rb.getString("LOOK_IN"));
            UIManager.put("FileChooser.filesOfTypeLabelText", rb.getString("FILE_TYPES"));
            UIManager.put("FileChooser.upFolderToolTipText", rb.getString("UP_ONE_LEVEL"));
            UIManager.put("FileChooser.homeFolderToolTipText", rb.getString("GO_HOME"));
            UIManager.put("FileChooser.newFolderToolTipText", rb.getString("NEW_FOLDER"));
            UIManager.put("FileChooser.listViewButtonToolTipTextlist", rb.getString("VIEW_FILE_LIST"));
            UIManager.put("FileChooser.detailsViewButtonToolTipText", rb.getString("SHOW_DETAILS"));
            UIManager.put("FileChooser.saveButtonText", rb.getString("SAVE"));
            UIManager.put("FileChooser.openButtonText", rb.getString("OPEN"));
            UIManager.put("FileChooser.updateButtonText", rb.getString("UPDATE"));
            UIManager.put("FileChooser.helpButtonText", rb.getString("HELP"));
        }
        
        
        
    }
    
    public int getSAMBA() {
        return SAMBA;
    }
    
    public void setSAMBA(int SAMBA) {
        this.SAMBA = SAMBA;
    }
    
    public TreePath BuscaStringEnArbol(JTree tree, String s) {
        DefaultMutableTreeNode nodo_iniciodebusqueda=null;
        TreePath tp=null;
        boolean saltafin=false;
        boolean empieza_comparacion=false;
        DefaultMutableTreeNode root= (DefaultMutableTreeNode)tree.getModel().getRoot();
        
        Enumeration enumeracion=root.breadthFirstEnumeration();
        
        if (tree.getSelectionPath()!=null && tree.getSelectionPath().getLastPathComponent()!=null) {
            nodo_iniciodebusqueda=(DefaultMutableTreeNode)tree.getSelectionPath().getLastPathComponent();
            empieza_comparacion=false;
        } else {
            nodo_iniciodebusqueda=root;
            empieza_comparacion=true;
        }
        Vector nueva=new Vector();
        while (enumeracion.hasMoreElements()) {
            DefaultMutableTreeNode nodo_act=(DefaultMutableTreeNode) enumeracion.nextElement();
            if (empieza_comparacion) nueva.add(nodo_act);
            if (nodo_act.equals(nodo_iniciodebusqueda)) empieza_comparacion=true;
        }
        
        if (!nodo_iniciodebusqueda.equals(root)) {
            enumeracion=root.breadthFirstEnumeration();
            while (enumeracion.hasMoreElements()) {
                DefaultMutableTreeNode nodo_act=(DefaultMutableTreeNode) enumeracion.nextElement();
                if (empieza_comparacion) nueva.add(nodo_act);
                if (nodo_act.equals(nodo_iniciodebusqueda)) empieza_comparacion=false;
            }
        }
        Enumeration new_enum=nueva.elements();
        empieza_comparacion=true;
        while (new_enum.hasMoreElements()) {
            DefaultMutableTreeNode nodo_act=(DefaultMutableTreeNode) new_enum.nextElement();
            
            if (empieza_comparacion) {
                String ns;
                if (nodo_act.getUserObject() instanceof UsuarioLDAP) {
                    UsuarioLDAP u=(UsuarioLDAP) nodo_act.getUserObject();
                    ns=AsciiUtils.convertNonAscii(u.toStringC()).toLowerCase();
                } else
                    ns=AsciiUtils.convertNonAscii(nodo_act.toString()).toLowerCase();
                if (ns.indexOf(s)>=0) {
                    TreeNode[] camino=nodo_act.getPath();
                    TreePath path=new TreePath(camino);
                    return path;
                }
            }
            if (nodo_act.equals(nodo_iniciodebusqueda)) empieza_comparacion=true;
            
        }
        return tp;
    }
    
    private void escribeEtcGroups() {
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter("/etc/group", false));
            String str;
            
            for (int i=0;i<unixGroups.size();i++) {
                Object ogrp=unixGroups.get(i);
                if (ogrp instanceof unixUtil.unixGroup) {
                    unixUtil.unixGroup g=(unixUtil.unixGroup) ogrp;
                    if (g.getGidNumber().equals("100")) {
                        g.setUsuarios(new Vector());
                        if (chGrupUsers.isSelected()) {
                            for (int j=0;j<usuarios.size();j++) {
                                UsuarioLDAP u=(UsuarioLDAP) usuarios.get(j);
                                g.ponUser(u.getUid());
                            }
                        } else {
                            for (int j=0;j<usuarios.size();j++) {
                                UsuarioLDAP u=(UsuarioLDAP) usuarios.get(j);
                                if (u.getGidNumber().equals("100")) {
                                    g.ponUser(u.getUid());
                                }
                            }
                        }
                    }
                    out.write(g.linea()+"\n");
                }
            }
            out.write("+::::::\n");
            out.close();
            
        } catch (Exception ex) {
            //setExcepcion(ex);
        }
    }
    
    
}
