/*
 * SambaDomain.java
 *
 * Created on 31 de julio de 2007, 20:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.ldap.objectos;

import javax.naming.NamingEnumeration;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.BasicAttribute;
import javax.naming.directory.BasicAttributes;
import javax.naming.directory.DirContext;
import javax.naming.directory.SearchResult;
import kemit.util.unixUtil;

/**
 *
 * @author JL
 */
public class SambaDomain {
    private String sambaDomainName;
    private String sambaSID;
    private String sambaAlgorithmicRidBase;
    private String sambaNextRid;
    private String sambaNextUserRid;
    private Exception excepcion;
    
    /** Creates a new instance of SambaDomain */
    
    public SambaDomain(DirContext dc) {
                        
        Attributes atn=new BasicAttributes(true);
        Attribute oc = new BasicAttribute("objectclass");        
        oc.add("sambaDomain");
        atn.put(oc);
        try {
            NamingEnumeration answer = dc.search("", atn);                         
            
            int i=0;
            
            while (answer.hasMore()) {
                
                // comprobar que solo exista un sambaDomain
                i++;                
                if (i>1) throw new KemitLdapException("Solo puede existir un objeto sambaDomain");
                
                SearchResult resultados = (SearchResult)answer.next();
                Attributes at = resultados.getAttributes();
                
                try {sambaDomainName = (String) at.get("sambaDomainName").get();}  catch (Exception e) {sambaDomainName="";}
                try {sambaSID = (String) at.get("sambaSID").get();}  catch (Exception e) {sambaSID="";}
                try {sambaAlgorithmicRidBase = (String) at.get("sambaAlgorithmicRidBase").get();}  catch (Exception e) {sambaAlgorithmicRidBase="";}
                try {sambaNextRid = (String) at.get("sambaNextRid").get();}  catch (Exception e) {sambaNextRid="";}
                try {sambaNextUserRid = (String) at.get("sambaNextUserRid").get();}  catch (Exception e) {sambaNextUserRid="";}                
            }
        } catch (Exception e) {
            setExcepcion(e);
        }
        setExcepcion(null);
    }

    public String getSambaDomainName() {
        return sambaDomainName;
    }

    public void setSambaDomainName(String sambaDomainName) {
        this.sambaDomainName = sambaDomainName;
    }

    public String getSambaSID() {
        if (sambaSID==null) {
            unixUtil.ejecutaS("net getlocalsid",null,"/");  
            String res=unixUtil.getRes();
            //"SID for domain SERVIDOR is:";
            res=res.substring(27).trim();
            //System.out.println(res);
            sambaSID=res;
        }
        return sambaSID;
    }

    public void setSambaSID(String sambaSID) {
        this.sambaSID = sambaSID;
    }

    public String getSambaAlgorithmicRidBase() {
        return sambaAlgorithmicRidBase;
    }

    public void setSambaAlgorithmicRidBase(String sambaAlgorithmicRidBase) {
        this.sambaAlgorithmicRidBase = sambaAlgorithmicRidBase;
    }

    public String getSambaNextRid() {
        return sambaNextRid;
    }

    public void setSambaNextRid(String sambaNextRid) {
        this.sambaNextRid = sambaNextRid;
    }

    public String getSambaNextUserRid() {
        return sambaNextUserRid;
    }

    public void setSambaNextUserRid(String sambaNextUserRid) {
        this.sambaNextUserRid = sambaNextUserRid;
    }

    public Exception getExcepcion() {
        return excepcion;
    }

    public void setExcepcion(Exception excepcion) {
        this.excepcion = excepcion;
    }
    
}
