/*
 * FileParser.java
 *
 * Created on 2 de agosto de 2007, 18:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.naming.directory.DirContext;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;

import kemit.csv.CsvReader;
import kemit.ldap.Principal;
import kemit.ldap.objectos.*;
import kemit.util.KemitParserException;
import kemit.util.KemitParserException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author JL
 */
public class FileParser {
    
    static String EX_NUMCOL_NONUMATTR=ResourceBundle.getBundle("textos").getString("EX_NUMCOL_NONUMATTR");
    static String EX_FICHERO_SIN_FILAS=ResourceBundle.getBundle("textos").getString("EX_FICHERO_SIN_FILAS");    
    static String EX_NUMCOL_BAJO=ResourceBundle.getBundle("textos").getString("EX_NUMCOL_BAJO");    
    
    private static int linea=1;
    private static boolean colgrupo=false;
    
    static kemit.csv.CsvReader reader;
    static String[] Cabeceras;
    
    /** Creates a new instance of FileParser */
    public FileParser() {
    }
    
    public static Vector ParseColumnasCSV(String s) throws KemitParserException {
        Vector v=new Vector();
        boolean nom=false;
        boolean sn=false;
        boolean sagaID=false;
        StringTokenizer st=new StringTokenizer(s,";");
        while (st.hasMoreElements()) {
            Columna c=new Columna(st.nextToken());
            if (c.LDAPKey.equals("givenName")) nom=true;
            if (c.LDAPKey.equals("sn")) sn=true;
            if (c.LDAPKey.equals("sagaID")) sagaID=true;
            v.add(c);
        }
        if (!sn ) throw new KemitParserException("Missing surname column (sn o cognom1)");
        if (!nom ) throw new KemitParserException("Missing name column (nom o givenName)");
        if (!sagaID ) throw new KemitParserException("Missing sagaID column (sagaID o #");
        return v;
    }
    
      
    
    public static Vector ParseColumnasCSVL(String[] s) throws KemitParserException {
        Vector v=new Vector();
        boolean nom=false;
        boolean sn=false;
        boolean sagaID=false;
        setColgrupo(false);
        for (int i=0;i<s.length;i++) {
            Columna c=new Columna(s[i]);
            if (c.LDAPKey.equals("givenName")) nom=true;
            if (c.LDAPKey.equals("sn")) sn=true;
            if (c.LDAPKey.equals("sagaID")) sagaID=true;
            v.add(c);
        }
        if (!sn ) throw new KemitParserException("Faltan columna Apellido (sn o cognom1)");
        if (!nom ) throw new KemitParserException("Faltan columna Nombre (nom o givenName)");
        if (!sagaID ) throw new KemitParserException("Faltan columna sagaID (sagaID o #");
        return v;
    }    
 
    
    public static Vector parseCSVFile(String file,DirContext dc,Principal padre) throws KemitParserException {        

        Vector ht=new Vector();
        setLinea(1);
        try {               
            reader = new CsvReader(file,';');

            try {
                reader.readRecord();
                Cabeceras=reader.getValues();
                reader.setHeaders(Cabeceras);
                Vector columnas=ParseColumnasCSVL(Cabeceras);
                
                while (reader.readRecord()) {
                    setLinea((int)reader.getCurrentRecord());
                    UsuarioLDAP usu=new UsuarioLDAP();            
                    
                    for (int j = 0; j < Cabeceras.length; j++) {
                        Columna c=(Columna) columnas.get(j);                                            
                        usu.masAtributos(c.getLDAPKey(),reader.get(j).trim(),false);                    
                    }
                    usu.normalizaAtributos(dc,padre);                    
                    ht.add(usu);                                            
                }
                reader.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }                        
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }                
        
        return ht;
    }
 
    public static Object parseXmlFile(String filename, boolean validating) {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setValidating(validating);

            Document doc = factory.newDocumentBuilder().parse(new File(filename));
            return doc;
        } catch (SAXException e) {            
            return e;
        } catch (ParserConfigurationException e) {
            return e;
        } catch (IOException e) {
            return e;
        }
    }

    public static class Columna {
        
        private String valor;
        private String LDAPKey;
        
        public Columna(String valor) {
            this.valor=valor;
            if (valor.equals("#")) LDAPKey="#";
            else if (valor.equals("id")) LDAPKey="sagaID";
            else if (valor.equals("GEN_IDALUMNE")) LDAPKey="sagaID";
            else if (valor.equals("nom")) LDAPKey="givenName";
            else if (valor.equals("GEN_NOM")) LDAPKey="givenName";
            else if (valor.equals("cognom1")) LDAPKey="sn";
            else if (valor.equals("cognom2")) LDAPKey="sn2";
            else if (valor.equals("GEN_COGNOM1")) LDAPKey="sn";
            else if (valor.equals("GEN_COGNOM2")) LDAPKey="sn2";            
            else if (valor.equals("grup")) {
                LDAPKey="grup";
                setColgrupo(true);
            }
            else LDAPKey=valor;
        }

        public String getValor() {return valor;}
        public void setValor(String valor) {this.valor = valor;}
        public String getLDAPKey() {return LDAPKey;}
        public void setLDAPKey(String LDAPKey) {this.LDAPKey = LDAPKey;}        
    }
    
    public static Vector ParseColumnasXML(Document doc) {        
        NodeList listColumnas = doc.getChildNodes();
        Vector c=new Vector(listColumnas.getLength());        
        for (int i=0;i<listColumnas.getLength();i++) {
            Node n=listColumnas.item(i);                                        
            NodeList nodos = n.getChildNodes();
            for (int j=0;j<nodos.getLength() ;j++) {
                Node n2=(Node)nodos.item(j);
                if (n2.hasChildNodes()) {
                    NodeList nodos2=n2.getChildNodes();
                    for (int z=0;z<nodos2.getLength();z++) {
                        Node n3=(Node)nodos2.item(z);
                        if (n3.hasAttributes()) {
                            NamedNodeMap nnm=n3.getAttributes();                                                        
                            for (int x=0;x<nnm.getLength();x++) {
                                Node n5=nnm.item(x);
                                c.add(new Columna(n5.getNodeValue()));
                            }
                        }
                    }
                }
                
            }
        }                               
        return c;
    }
    
    public static Vector usuariosXML(Document doc,DirContext dc,Principal padre) throws KemitParserException {
        Vector columnas=ParseColumnasXML(doc);
        NodeList listFilas = doc.getElementsByTagName("fila");
        Vector u=new Vector(listFilas.getLength());
        if (listFilas.getLength()==0) throw new KemitParserException(EX_FICHERO_SIN_FILAS);        
        for (int i=0;i<listFilas.getLength();i++) {
            Node n=listFilas.item(i);                                        

            Element ele = (Element)n;
            NodeList nodos = ele.getElementsByTagName("columna");
            
            if (nodos.getLength()!=columnas.size()) throw new KemitParserException(EX_NUMCOL_NONUMATTR);
            
            UsuarioLDAP usu=new UsuarioLDAP();
            
            for (int j=0;j<nodos.getLength() ;j++) {
                Element otro = (Element)nodos.item(j);
                NodeList textFNList = otro.getChildNodes();
                Columna c=(Columna) columnas.get(j);                                            
                
                String valor=((Node)textFNList.item(0)).getNodeValue().trim();                    
                usu.masAtributos(c.getLDAPKey(),valor,false);
                usu.setUidNumber("");
            }
            usu.normalizaAtributos(dc,padre);
            u.add(usu);            
        }               
        return u;
    }

    public static int getLinea() {
        return linea;
    }

    public static void setLinea(int aLinea) {
        linea = aLinea;
    }

    public static boolean isColgrupo() {
        return colgrupo;
    }

    public static void setColgrupo(boolean aColgrupo) {
        colgrupo = aColgrupo;
    }

}
