/*
 * OpenLdapUtil.java
 *
 * Created on 25 de julio de 2007, 20:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package kemit.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.DirContext;

/**
 *
 * @author JL
 */
public class OpenLdapUtil {
    
    
    static boolean debug=false;
    static private String strError;
    private static Exception excepcion;
    private static String err;
    private static String res;
    
    static String inetorgpersonEsquema="/etc/openldap/schema/inetorgperson.schema";
    static String inetorgpersonEsquemaTMP="/etc/openldap/schema/inetorgpersonTMP.schema";
    static String inetorgpersonEsquemaOLD="/etc/openldap/schema/inetorgpersonOLD.schema";
    
    
    static String pathToSlapd="/etc/openldap/slapd.conf";
    

    
    static String[] sagaID={"# sagaID",
                    "# Numeric or alphanumeric identifier assigned to a person in SAGA application",
                    "# of Generalitat de Catalunya systems, typically based",
                    "# on spanish DNI.  Single valued.",
                    "attributetype ( 2.16.840.1.113730.3.1.400",
                    "	NAME 'sagaID'",
                    "	DESC 'identifies an user of SAGA (Generalitat de Catalunya) '",
                    "	EQUALITY caseIgnoreMatch",
                    "	SUBSTR caseIgnoreSubstringsMatch",
                    "	SYNTAX 1.3.6.1.4.1.1466.115.121.1.15",
                    "	SINGLE-VALUE )",
                    "",
                    "",
                    "# inetOrgPerson",
                    "# The inetOrgPerson represents people who are associated with an",
                    "# organization in some way.  It is a structural class and is derived",
                    "# from the organizationalPerson which is defined in X.521 [X521].",
                    "objectclass	( 2.16.840.1.113730.3.2.2",
                    "    NAME 'inetOrgPerson'",
                    "	DESC 'RFC2798: Internet Organizational Person'",
                    "    SUP organizationalPerson",
                    "    STRUCTURAL",
                    "	MAY (",
                    "		audio $ businessCategory $ sagaID $ carLicense $ departmentNumber $",
                    "		displayName $ employeeNumber $ employeeType $ givenName $",
                    "		homePhone $ homePostalAddress $ initials $ jpegPhoto $",
                    "		labeledURI $ mail $ manager $ mobile $ o $ pager $",
                    "		photo $ roomNumber $ secretary $ uid $ userCertificate $",
                    "		x500uniqueIdentifier $ preferredLanguage $",
                    "		userSMIMECertificate $ userPKCS12 )",
                    "	)",
                    ""};
    
    
    
    /**
     * Creates a new instance of OpenLdapUtil
     */
    
    public OpenLdapUtil() {
    }
    
    public OpenLdapUtil(boolean debug) {
        this.debug=debug;
    }
    
    
    public static boolean isSamba() {
        return unixUtil.fichero_tiene(pathToSlapd,"/etc/openldap/schema/samba3.schema");
    }
    
    public static boolean anyadeSamba() {
        return unixUtil.fichero_pon(pathToSlapd,"/etc/openldap/schema/yast.schema","include         /etc/openldap/schema/samba3.schema");        
    }
    
   
    public static boolean isEsquemaSamba(DirContext schema) throws NamingException {
        
        return true;
    }
    
    
    public static boolean isEsquemaSAGA(DirContext schema) throws NamingException {
        DirContext dircon = schema.getSchema("");
        DirContext personSchema = (DirContext)dircon.lookup("ClassDefinition/inetOrgPerson");
        NamingEnumeration bds = personSchema.getAttributes("").getAll();
        while (bds.hasMore()) {
            Attribute attr = (Attribute)bds.next();
            if (debug) {
                System.out.println("At="+attr.getID()+" valor="+attr.get());
                System.out.println("A="+attr);
            }

            if (attr.getID().equals("MAY")) {
                if (attr.contains("sagaID"))  {
                    if (debug) System.out.println("lo tengo");
                    return true;
                }
                else {
                    if (debug) System.out.println("NO lo tengo");
                    return false;
                }
            }
        }
        return false;        
    }
    
    
    public static boolean anyadeEsquemaSAGA() {
        boolean bien=true;
        
        
        bien=unixUtil.fichero_cambia(inetorgpersonEsquema,inetorgpersonEsquemaTMP,"# The inetOrgPerson represents people",sagaID,20);
        if (bien) bien=unixUtil.fichero_copia(inetorgpersonEsquema,inetorgpersonEsquemaOLD);
        if (bien) bien=unixUtil.fichero_copia(inetorgpersonEsquemaTMP,inetorgpersonEsquema);        
        return bien;
    }
    
    public static boolean rebotaLDAP() {
        return unixUtil.ejecuta("/etc/init.d/ldap restart",null,"/root");
    }
   

}
